<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//BARMAZ_MODULE_INFO
defined('_BARMAZ_VALID') or die("Access denied");

class catalogModelgoods extends SpravModel {

	private $arr_table_clean=array();
	private $inf_img_goods=array(); 

	public function cleanLinkFromGoods(){
		// удаление ссылок
		$query = "DELETE FROM #__goods_links WHERE g_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_data WHERE obj_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_discounts WHERE g_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_analogs WHERE g_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_analogs WHERE a_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_sets WHERE g_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_prices WHERE p_g_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_stat WHERE gs_goods_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_feedbacks WHERE gf_goods_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_additionals WHERE g_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_additionals WHERE ad_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_options_data WHERE od_obj_id NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_opt_vals_data WHERE ovd_od_id NOT IN (SELECT od_id FROM #__goods_options_data)".$this->_db->getDelimiter();
		$query.= "DELETE FROM #__goods_videos WHERE v_gid NOT IN (SELECT g_id FROM #__goods)".$this->_db->getDelimiter();
		$this->_db->setQuery($query); if(!$this->_db->query_batch(true,true)) return false;
		return true;
	}
	public function cleanRecords()	{
		// помечаем дочерние таблицвы
		$this->arr_table_clean['m_table']="goods";
		$this->arr_table_clean['m_key']="g_id";
		$this->arr_table_clean['m_deleted']="g_deleted";
		$this->arr_table_clean['ch_table']="goods_img";
		$this->arr_table_clean['ch_deleted']="i_deleted";
		$this->arr_table_clean['ch_key']="i_gid";
		parent::markDeleteTrashChildsTable($this->arr_table_clean);
		$this->arr_table_clean['ch_table']="goods_videos";
		$this->arr_table_clean['ch_deleted']="v_deleted";
		$this->arr_table_clean['ch_key']="v_gid";
		parent::markDeleteTrashChildsTable($this->arr_table_clean);
		if(parent::cleanRecords()) return $this->cleanLinkFromGoods();	else return false;
	}
	public function afterSaveLinks($current_group,$group_array,$arr_psid) {
		if(is_array($group_array) && in_array($current_group, $group_array)){
			return true;
		} elseif(!is_array($group_array) || (is_array($group_array) && !in_array($current_group,$group_array)))	{
			$sql = "UPDATE `#__goods` SET `#__goods`.`g_main_grp` =";
			$sql.= " (SELECT `#__goods_links`.`parent_id` FROM `#__goods_links` WHERE `#__goods_links`.`g_id` = `#__goods`.`g_id` LIMIT 1)";
			$sql.= " WHERE `#__goods`.`g_main_grp`=".$current_group;
			$sql.= " AND `#__goods`.`g_id` IN (".implode(",", $arr_psid).")";
			$this->_db->setQuery($sql);
			if($this->_db->query()){
				$sql = "UPDATE `#__goods` SET `#__goods`.`g_main_grp` = 0";
				$sql.= " WHERE `#__goods`.`g_main_grp`=".$current_group;
				$sql.= " AND `#__goods`.`g_id` IN (".implode(",", $arr_psid).")";
				$this->_db->setQuery($sql);
				return $this->_db->query();
			}
		}
		return false;
	}
	public function getGoods($shortdata=0,$ids=array()) {
		if($shortdata) $query = "SELECT g_id as id, g_name as title FROM `#__goods` WHERE `g_deleted`=0";
		else $query = "SELECT * FROM `#__goods` WHERE `g_deleted`=0";
		if(count($ids)>0) $query.=" AND g_id IN ('".implode("','",$ids)."')";
		$this->_db->setQuery($query);
		return $this->_db->loadObjectList();
	}

	public function updateThumb($psid,$thumb){
		return self::updateFldGoods($psid,'g_thumb',$thumb);
		/*$sql="UPDATE #__goods SET g_thumb='".$thumb."' WHERE g_id='".$psid."'";
		$this->_db->setQuery($sql);
		return $this->_db->query();
		*/
	}
	/**
	 * обновление содержания конкретного дополнительного поля таблицы товаров 
	 * @todo перевести на использование функции родительского класса 
	 * @param int $psid
	 * @param string $fld_name
	public function updateMediumImage($psid,$medium_image){
		return self::updateFldGoods($psid,'g_medium_image',$medium_image);
		/*$sql="UPDATE #__goods SET g_medium_image='".$medium_image."' WHERE g_id='".$psid."'";
		$this->_db->setQuery($sql);
		return $this->_db->query();
		*/
	}
	/**
	 * Обновление содержания поля записи товара
	 * поле должно быть, и принимает текстовое содержание
	 * @param int $psid - ид записи
	 * @param  string $fld имя поля
	 * @param string $content
	 * @return unknown
	 */
	public function updateFldGoods($psid,$fld,$content){
		$sql="UPDATE #__goods SET `".$fld."`='".$content."' WHERE g_id='".$psid."'";
		$this->_db->setQuery($sql);
		return $this->_db->query();
	}
	
	/**
	 * перенос дополнительного поля(нескольких) в основную таблицу - ручная сервисная операция
	 * используется , когда у всех товаров необходим этот признак
	 * служит уменьшению времени обработки в моменте запроса товара
	 * алгоритм работы :
	 * 1. создаем поле в основной таблице нужного типа заполняем его значением по умолчанию 
	 * alter table `c_goods` add column `g_thumb_slider` varchar(64) NULL COMMENT 'эскиз слайдера' after `g_comments`, add column `g_thumb_sl_title` varchar(255) NULL COMMENT 'тайтл эскиза слайдера' after `g_thumb_slider`, add column `g_thumb_sl_alt` varchar(255) NULL COMMENT 'алт эскиза слайдера' after `g_thumb_sl_title`;
	 * 2. правим метадату основной таблицы
	 * 3. запускаем этот скрипт
	 * 4. Запускаем в админке пересчет видимости полей 
	 * @param array $add_fld
	 * @param array $main_fld
	 */
	public function addAdditionFieldinMainTable(array $add_fld,array $main_fld){
		// запрос на наличие данных по доп полю
		// если это изображение пути у нас прописаны в метадате
		// делаем апдейт основной таблицы
		// проводим удаление дополнительного поля
		
	}
	/**
	 * сохранение товара в основную таблицу
	 * сохранение,создание и преобразование изображений товара
	 * дополнение изображений водяным знаком
	 * @return boolean|unknown
	 */
	public function save()	{
		$mdl = Module::getInstance();
		$reestr = $mdl->get('reestr');
		$psid = $reestr->get('psid');
		$generate_sku_automaticly = Module::getInstance("catalog")->getParam("generate_sku_automaticly");
		
		if($generate_sku_automaticly){
			$sku=Request::getSafe("g_sku","EMPTY_VALUE");
		} else {
			$sku=Request::getSafe("g_sku","");
			if(!$sku) return false;
		}	
		if (!$this->isGoods($sku,$psid)) {
			$new_psid=parent::save();		
			if ($new_psid) {
				//var_dump($new_psid);
				// операции только при создании нового товара
				// секция изображений основной товароной позиции
				// добавление функционала
				// наложение водяного знака
				// создание webp экземпляра
				
				// @todo результат по генерации изображений надо запустить паралельным потоком 
				// сейчас, если по какой то причине не сработает создание эскиза остальные изображдения так же 
				// не создадутся
				
				// @fixme запрос к элементу товара идет на каждом варианте создания изображения - избыточно
				
				//@todo неплохо иметь лог действий при создании товара , для понимания ошибок
								
				$res=$this->getElement($new_psid);
				
				//Util::showArray($res);
				// нет данных по элементу - просто выходим
				$reestr->msg_img=array("result"=>true,"info"=>array());				
				if (!$res) return false;
				// информатор по сохранению позиции
				
				// первым делом отработаем источник изображений
				
				
				// источник всех изображений - главная картинка которую заливают - она есть только при апдейтах
				$filename=Files::splitAppendix($res->g_image, true);
				// если картинки нет - выходим
				//if (!$filename) return false;
				$result=$this->checkGoodsImg($new_psid,'g_image',$res->g_image,$res->g_image,$filename,$reestr->msg_img);			
				// подумать про выделение обработки изображений в отдельную функцию
				$result=$this->checkGoodsImg($new_psid,'g_thumb',$res->g_image,$res->g_thumb,$filename,$reestr->msg_img);
				$result=$this->checkGoodsImg($new_psid,'g_medium_image',$res->g_image,$res->g_medium_image,$filename,$reestr->msg_img);
				// создание эскиза для слайдера
				$result=$this->checkGoodsImg($new_psid,'df_thumb_slider',$res->g_image,$res->df_thumb_slider,$filename,$reestr->msg_img);
				Util::logFile($reestr->msg_img);
				// контроль размера основного изображения
				
				$sql="UPDATE #__goods SET g_change_date=NOW(), g_change_uid=".User::getInstance()->getID()." WHERE g_id=".$new_psid;
				$this->_db->setQuery($sql);
				$this->_db->query();
			}
		} else return false;
		if($generate_sku_automaticly && $sku=="EMPTY_VALUE") $this->updateSKU($new_psid);
		return $new_psid;
	}

	public function getGroupsFields($linkArray){
		if (!is_array($linkArray) || !count($linkArray)) return array();
		$sql = "SELECT f.*, ggf.parent_id  FROM #__fields_list AS f";
		$sql.=" LEFT JOIN #__goods_group_fields AS ggf ON ggf.f_id=f.f_id";
		$sql.=" WHERE f.f_custom=1 AND f.f_table='goods'";
		$sql.=" AND ggf.parent_id IN ('".implode("','",$linkArray)."') ";
		$sql.=" ORDER BY f.f_descr";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList("f_id");
	}
	public function getCommonFields(){
		$sql = "SELECT f.*  FROM #__fields_list AS f";
		$sql.=" WHERE f.f_custom=0 AND f.f_table='goods'";
		$sql.=" ORDER BY f.f_descr";
		$this->_db->setQuery($sql);
		return $this->_db->loadObjectList("f_id");
	}
	
	public function cleanNonGroupsFields($psid,$linkArray){
		$fcList=$this->getCommonFields();
		$fbgList=$this->getGroupsFields($linkArray);
		if (is_array($fbgList) && count($fbgList)){
			$fbgList_IDS=array_keys($fbgList);
			if (is_array($fcList) && count($fcList)){
				$fcList_IDS = array_keys($fcList);
				$fList_IDS = array_merge($fbgList_IDS, $fcList_IDS);
			} else $fList_IDS=$fbgList_IDS;
			$sql = "DELETE FROM #__goods_data WHERE obj_id=".$psid." AND field_id NOT IN(".implode(",",$fList_IDS).")";
			$this->_db->setQuery($sql);
			$this->_db->query();
		}
	}
	public function getElementClone($psid=0,$fillempty=false) {
		$row = $this->getElement($psid, $fillempty);
		if (is_object($row)){
			$meta = $this->meta;
			foreach($meta->field as $ind=>$field)	{
				if ($field == $meta->keystring) $row->{$field}=0;
				if($meta->input_type[$ind]=="image" || $meta->input_type[$ind]=="file" || $field =="g_sku") $row->{$field}="";
			}
		}
		return $row;
	}
	// May be for remove ??? Check first !!! Currently used only in save()
	public function isGoods($val,$psid){
		$query = "SELECT COUNT(*) FROM #__goods WHERE g_sku='".strval($val)."'";
		if ($psid) $query.=" AND g_id<>'".$psid."'";
		$this->_db->setQuery($query);
		$cnt = $this->_db->loadResult();
		return (intval($cnt) != 0);
	}
	public function getAnalogs($psid){
		$sql="SELECT DISTINCT a.a_id AS id, CONCAT(g.g_sku,' : ', g.g_name) AS title FROM #__goods_analogs AS a,#__goods AS g WHERE g.g_id=a.a_id AND a.g_id=".$psid;
		$this->_db->setQuery($sql);
		return $this->_db->loadAssocList();
	}
	
	public function saveAnalogs($psid,$analogs,$reverse=true){
		if($reverse){
			$sql="DELETE FROM #__goods_analogs WHERE g_id=".$psid." OR a_id=".$psid.$this->_db->getDelimiter();
		}
		else
		{
			$sql="DELETE FROM #__goods_analogs WHERE g_id=".$psid.$this->_db->getDelimiter();
		}
		$res=true;
		if(count($analogs)){
			foreach($analogs as $aid){
				if ($aid!=$psid) {
					$sql.="INSERT INTO #__goods_analogs VALUES(".$psid.",".$aid.")".$this->_db->getDelimiter();
					if($reverse) $sql.="INSERT INTO #__goods_analogs VALUES(".$aid.",".$psid.")".$this->_db->getDelimiter();
				}
			}
		}
		$this->_db->setQuery($sql);
		return $this->_db->query_batch(true,true);		
	}
	public function getAdditionals($psid){
		$sql="SELECT DISTINCT a.ad_id AS id, CONCAT(g.g_sku,' : ', g.g_name) AS title FROM #__goods_additionals AS a,#__goods AS g WHERE g.g_id=a.ad_id AND a.g_id=".$psid;
		$this->_db->setQuery($sql);
		return $this->_db->loadAssocList();
	}
	public function saveAdditionals($psid,$additional){
 	   $sql="DELETE FROM #__goods_additionals WHERE g_id=".$psid.$this->_db->getDelimiter();		
	   $res=true;
		if(count($additional)){
			foreach($additional as $aid){
				if ($aid!=$psid) {
					$sql.="INSERT INTO #__goods_additionals VALUES(".$psid.",".$aid.")".$this->_db->getDelimiter();
				}
			}
		}
		$this->_db->setQuery($sql);
		return $this->_db->query_batch(true,true);
	}
	
	public function getDiscounts($psid){
		$sql="SELECT DISTINCT gd.d_id AS id, d.d_name AS title FROM #__goods_discounts AS gd, #__discounts AS d WHERE d.d_id=gd.d_id AND gd.g_id=".$psid;
		$this->_db->setQuery($sql);
		return $this->_db->loadAssocList();
	}
	public function saveDiscounts($psid, $discounts){
		$sql="DELETE FROM #__goods_discounts WHERE g_id=".$psid.$this->_db->getDelimiter();
		$res=true;
		if(count($discounts)){
			foreach($discounts as $did){
				$sql.="INSERT INTO #__goods_discounts VALUES(".$psid.",".$did.")".$this->_db->getDelimiter();
			}
		}
		$this->_db->setQuery($sql);
		return $this->_db->query_batch(true,true);
	}
	public function getSKUPath($psid){
		$sql="SELECT CONCAT(g_sku,' : ',g_name) FROM #__goods WHERE g_id=".$psid;
		$this->_db->setQuery($sql);
		return $this->_db->loadResult();
	}
	public function getComplectSet($psid){
		$sql="SELECT DISTINCT a.s_id AS id, CONCAT(g.g_sku,' : ', g.g_name) AS title, a.s_quantity AS quantity FROM #__goods_sets AS a,#__goods AS g WHERE g.g_id=a.s_id AND a.g_id=".$psid;
		$this->_db->setQuery($sql);
		return $this->_db->loadAssocList();
	}
	public function saveComplectSet($psid,$complects){
		$sql="DELETE FROM #__goods_sets WHERE g_id=".$psid.$this->_db->getDelimiter();
		$res=true;
		if(count($complects)){
			foreach($complects as $aid=>$quantity){
				if ($aid!=$psid && $quantity) {
					$sql.="INSERT INTO #__goods_sets VALUES(".$psid.",".$aid.",".$quantity.")".$this->_db->getDelimiter();
				}
			}
		}
		$this->_db->setQuery($sql);
		return $this->_db->query_batch(true,true);
	}
	public function updateSKU($psid){
		$sku_prefix = Module::getInstance()->getParam("automatic_sku_prefix");
		$new_sku = $sku_prefix.$psid;
		$sql="SELECT COUNT(*) FROM #__goods WHERE g_sku='".$new_sku."' AND g_id<>".$psid;
		$this->_db->setQuery($sql);
		if ($this->_db->loadResult()>0){
			$new_sku=$sku_prefix.$psid."-".md5($psid);
		}
		$sql="UPDATE #__goods SET g_sku='".$new_sku."' WHERE g_id=".$psid;
		$this->_db->setQuery($sql);
		return $this->_db->query();
	}
	/**********************************************************************************/
	public function updatePricesFromComplect($psid){
		$g_price_1=0;
		$g_price_2=0;
		$g_price_3=0;
		$g_price_4=0;
		$g_price_5=0;
		$sql="SELECT g.g_id, g.g_price_1, g.g_price_2, g.g_price_3, g.g_price_4, g.g_price_5, s.s_quantity";
		$sql.=" FROM #__goods_sets AS s, #__goods AS g";
		$sql.=" WHERE s.s_id=g.g_id AND s.g_id=".$psid;
		$this->_db->setQuery($sql);
		$complect = $this->_db->loadObjectList();
		if(count($complect)){
			foreach($complect as $gset) {
				$g_price_1 = $g_price_1 + $gset->g_price_1 * $gset->s_quantity;
				$g_price_2 = $g_price_2 + $gset->g_price_2 * $gset->s_quantity;
				$g_price_3 = $g_price_3 + $gset->g_price_3 * $gset->s_quantity;
				$g_price_4 = $g_price_4 + $gset->g_price_4 * $gset->s_quantity;
				$g_price_5 = $g_price_5 + $gset->g_price_5 * $gset->s_quantity;
			}
			$sql="UPDATE #__goods SET g_price_1='".$g_price_1."', g_price_2='".$g_price_2."', g_price_3='".$g_price_3."', g_price_4='".$g_price_4."', g_price_5='".$g_price_5."' WHERE g_id='".$psid."'";
			$this->_db->setQuery($sql);
			return $this->_db->query();
		}
		return false;
	}
	public function updateAllPricesFromComplects(){
		if(catalogConfig::$complectPriceAsGoodsSum){
			$sql = "UPDATE #__goods g
					INNER JOIN (
						SELECT `id`, SUM(`quantity`*`price_1`) AS sum_1, SUM(`quantity`*`price_2`) AS sum_2, SUM(`quantity`*`price_3`) AS sum_3, SUM(`quantity`*`price_4`) AS sum_4, SUM(`quantity`*`price_5`) AS sum_5 FROM(
							SELECT mgs.g_id AS id, mgs.s_quantity AS quantity, mg.g_price_1 AS price_1, mg.g_price_2 AS price_2, mg.g_price_3 AS price_3, mg.g_price_4 AS price_4, mg.g_price_5 AS price_5 FROM #__goods_sets mgs
							LEFT JOIN #__goods mg ON mg.g_id = mgs.s_id
							WHERE mg.g_deleted = 0 AND mg.g_enabled =1
						) as tmp GROUP BY tmp.`id`
					) x ON g.g_id = x.id
					SET g.g_price_1 = x.sum_1, g.g_price_2 = x.sum_2, g.g_price_3 = x.sum_3, g.g_price_4 = x.sum_4, g.g_price_5 = x.sum_5 WHERE g.g_type = 5";
			$this->_db->setQuery($sql);
			return $this->_db->query();
		} else {
			return true;
		}
	}	
	/**
	 * наложение водяного знака на изображение
	 * водяной знак находится по пути PATH_WM  - PATH_IMAGES.'WM'
	 * в зависимости от необходимого размера
	 * файлы водяных знаков подготавливаются для проекта:
	 * формат прозрачный png
	 * имя файла wm_{width}_{height}.png
	 *     
	 * @param string $dest - изображение на которое накладывается водяной знак 
	 * @param int $width
	 * @param int $height
	 */
	public function checkWM($dest,$width,$height)
	{
		//$wm_file=PATH_WM."wm-".$width."-".$height.".png";
		// если водяного знака нет - выходим
		//var_dump($dest,$wm_file,is_file($wm_file));
		//if(!is_file($wm_file)) return $dest;		else 
		return Files::addWaterMark($dest, "",$width,$height);
	}
	/**
	 * преобразование файла к webp
	 * @param string $dest
	 */
	 
	public function checkWebp($dest)
	{
		$res_create=false; // результат преобразования - логика
		$res=Files::webpImage($dest,85,false,$res_create);
		if(!$res_create) return $dest; else return $res;
	}
	public function getGoodsImgInfo($type_img)
	{
		$info = new stdClass();
		switch($type_img)
		{
			case 'g_thumb':
				$info->autocreate=catalogConfig::$thumbAutoCreate;
				$info->autoresize=catalogConfig::$thumbAutoResize;
				$info->width=catalogConfig::$thumb_width;
				$info->height=catalogConfig::$thumb_height;
				$info->applWM=catalogConfig::$thumbApplWM;
				$info->main_fld="g_thumb"; // поле cоздаваемого изображения
				$info->part_path="thumbs"; // часть пути
				$info->quality=100;
				$info->table='main';
				$info->full_path_dest=false;
				$info->check_img=array('prezent'=>0,'sizes'=>0,'webp'=>0,'watermark'=>0);
				$info->uploadPath=BARMAZ_UF_PATH.'catalog'.DS.'i'.DS.$info->part_path.DS;
				break;
			case 'g_medium_image':
				$info->autocreate=catalogConfig::$mediumImgAutoCreate;
				$info->autoresize=catalogConfig::$mediumImgAutoResize;
				$info->width=catalogConfig::$mediumImgWidth;
				$info->height=catalogConfig::$mediumImgHeight;
				$info->applWM=catalogConfig::$mediumImgApplWM;
				$info->main_fld="g_medium_image"; // поле cоздаваемого изображения
				$info->quality=100;
				$info->part_path="medium"; // часть пути
				$info->table='main';
				$info->full_path_dest=false;
				$info->check_img=array('prezent'=>0,'sizes'=>0,'webp'=>0,'watermark'=>0);
				$info->uploadPath=BARMAZ_UF_PATH.'catalog'.DS.'i'.DS.$info->part_path.DS;
				break;
			case 'df_thumb_slider':
				$info->autocreate=catalogConfig::$thumbsld_AutoCreate;;
				$info->autoresize=catalogConfig::$thumbsld_AutoResize;
				$info->width=catalogConfig::$thumbsld_width;
				$info->height=catalogConfig::$thumbsld_height;
				$info->quality=100;
				$info->applWM=catalogConfig::$thumbsldApplWM;
				$info->main_fld="df_thumb_slider"; // поле cоздаваемого изображения
				$info->part_path="goods"; // часть пути
				$info->table='additional';
				$info->full_path_dest=BARMAZ_UF_PATH.'catalog'.DS.'_add'.DS;
				$info->check_img=array('prezent'=>0,'sizes'=>0,'webp'=>0,'watermark'=>0);
				$info->uploadPath=BARMAZ_UF_PATH.'catalog'.DS.'_add'.DS.$info->part_path.DS;
				break;
			case 'g_image':
				$info->autocreate=false;
				$info->autoresize=catalogConfig::$MainImg_AutoResize;
				$info->width=catalogConfig::$MainImg_width;
				$info->height=catalogConfig::$MainImg_height;
				$info->applWM=catalogConfig::$MainImgApplWM;
				$info->quality=100;
				$info->main_fld="g_image"; // поле cоздаваемого изображения
				$info->part_path="fullsize"; // часть пути
				$info->table='main';// в какой таблице запись
				$info->full_path_dest=false; // есть ли полный путь к изображению
				$info->check_img=array('prezent'=>0,'sizes'=>0,'webp'=>0,'watermark'=>0);
				$info->uploadPath=BARMAZ_UF_PATH.'catalog'.DS.'i'.DS.$info->part_path.DS;
				break;
				
			default:
				return false;
				break;
		}
		
		return $info;
	}
	
	/**
	 * проверка состояния изображений товара
	 */
	public function testGoodsImg($new_psid,$type_img)
	{
		$info=$this->getGoodsImgInfo($type_img);
		if(!$info) return false;
	}
	/**
	 * создание варианта изображения из источника
	 * внутри приведение к размерам
	 * преобразование в webp - если надо    
	 * наложение водяного знака если надо
	 * сохранение информации в базе
	 *  
	 * @param int $psid - ид основной записи
	 * @param string $src_file - путь к файлу источнику 
	 * @param object $dest_info - информация о создаваемом файле все внутри объекта
	 */
	public function createImg($psid,$src_file,$dest_info)
	{
		/*
		 * $dest_info : object
		[autocreate]	====> 	1 (typeof string)
		[autoresize]	====> 	1 (typeof string)
		[width]	====> 	150 (typeof string)
		[height]	====> 	100 (typeof string)
		[applWM]	====> 	0 (typeof string)
		[main_fld]	====> 	df_thumb_slider (typeof string)
		[part_path]	====> 	goods (typeof string)
		[table]	====> 	additional (typeof string)
		[full_path_dest]	====> 	D:\worktemp\stap_zion1\userfiles\catalog\_add\ (typeof string)
		check_img : array
		[prezent]	====> 	0 (typeof integer)
		[sizes]	====> 	0 (typeof integer)
		[webp]	====> 	0 (typeof integer)
		[watermark]	====> 	0 (typeof integer)
		[uploadPath]	====> 	D:\worktemp\stap_zion1\userfiles\catalog\_add\goods\ (typeof string)
		*/
		
		// автосозданием пренебрежем - раз мы тут надо создавать
		// наличие файла источника подтверждено - иначе бы сюда не попали
		// наличие файла приемника - вопрос - может надо иметь доп подтверждение по перезаписи, либо уточнять это выше
		
		
		// размеры приемника из свойств
		// bvz 
		// вопрос названия файла - наверное надо смотреть из настроек - сохранять уникальное имя или берем
		// аббревиатуру из названия поля ид товара и метки времени - тут вопрос открытый 
		// пока достанем 
		//: PATHINFO_DIRNAME, PATHINFO_BASENAME, PATHINFO_EXTENSION и PATHINFO_FILENAME. 
		$filename=pathinfo($src_file, PATHINFO_BASENAME);
		$name_create_file=Files::clearMTFilename($filename);
		$dst_file=$dest_info->uploadPath.Files::splitAppendix($name_create_file,true);
		$res_copy=array();
		$createdFile=Files::resizeImageNew($src_file,$dst_file,$dest_info->width,$dest_info->height,				
		$dest_info->quality,catalogConfig::$webp_autocreate,$res_copy);
		
		
		if(!$createdFile){
			$message=$res_copy." ".$dst_file." (".$createdFile.")";
			Util::logFile($message, 'error create image', false, false,'image_Create.log'); 
		    Util::logFile($dest_info, 'info image', false, false,'image_Create.log'); 
		}
		//var_dump($res_copy,$dst_file,$createdFile);
		
		
		if($createdFile){
			$result=true;
			// у нас файл создался и он уже webp если надо
			// накладываем на него водяной знак если необходимо
			if($dest_info->applWM){
				// вот тут засада  - у нас  могут быть неточности с размером после пережимания
				// поэтому еще раз проверим реальные размеры получившегося изображения
				$imageInfo_dst = getimagesize($dst_file);
				$reswm=Files::addWaterMark($dst_file, "",$imageInfo_dst[0],$imageInfo_dst[1]);
			}
			
			// теперь можно апдейтиить состояние  изображения в базе
			
			$fileNameForSave=pathinfo($dst_file, PATHINFO_BASENAME);
			if($dest_info->table==='additional'){
				$result=$this->insertUpdateAdditionField('goods',$psid,$dest_info->main_fld,$fileNameForSave);
				//var_dump(Database::getInstance()->getQuery()." ".Database::getInstance()->getLastError());		
			}
			else {$result=$this->updateFldGoods($psid,$dest_info->main_fld,$fileNameForSave);
			}
				return $result;
		}
	  	return false;	
	}
	/**
	 * проверка и создание дополнительных изображений к товару
	 * @param string $new_psid - ид записи
	 * @param string $type_img - тип изображения (thumb,medium_image,image,df_thumb_slider )
	 * @param string $filename - имя файла источника без путей 
	 * @param string $name_img - имя файла изображения которое будет присвоено создаваемому 
	 * @param string $fld_img - содержание поля создаваемого изображения(проверка на наличие)  
	 * @param array $report  - массив с отладочной информацией 
	 * 	 */
	public function checkGoodsImg($new_psid,$type_img,$name_img,$fld_img,$filename,&$report)
	{
		
		$info=$this->getGoodsImgInfo($type_img);
		if(!$info) return false;
		
		// создание изображения
		//Util::showArray($_FILES,'files');
		array_push($report['info'],$type_img." ".Text::_("Before check part"));		
		// тут еще вариант когда у нас все данные уже в базе а не первичное сохранение
		// либо есть замена изображения
		$imgFromBase=false;
		
		if($type_img == 'image') {
			// проверяем основное изобюражение
			$condition=@$_FILES["g_image"]["name"];}
		else {
			// проверяем другое изображение
			$condition=@$_FILES["g_image"]["name"] && !@$_FILES[$main_fld]["name"];
		}
		
		if($condition===null){
		// у нас изображение основное и нет картинки на замену - просто работаем 
		// с проверкой изображения в базе - приводим его к указанным в настройках показателям
			$imgFromBase=true;
		}
		if ($info->autocreate && $info->width && $info->height && $condition ) {
			if(!$info->full_path_dest){
				$_dest=BARMAZ_UF_PATH."catalog".DS."i".DS.$info->part_path.DS.$filename;
				$_dest_folder=BARMAZ_UF_PATH."catalog".DS."i".DS.$info->part_path.DS.Files::getAppendix($filename);
			}
			else{
				$_dest=$info->full_path_dest.$info->part_path.DS.$filename;
				$_dest_folder=$info->full_path_dest.$info->part_path.DS.Files::getAppendix($filename);
			}
			
				//var_dump($_dest,$fld_img,$filename,file_exists($_dest));
			if ((!$fld_img)||(!file_exists($_dest))) {
				// нет в таблице или нет самого файла и есть из чего создавать  - создаем
				// проверим путь назначения
				
				Files::checkFolder($_dest_folder, true);
				// истоник изображения всегда главная картинка
				$_src=BARMAZ_UF_PATH."catalog".DS."i".DS."fullsize".DS.$filename;
				if(!$info->full_path_dest) $_dest=BARMAZ_UF_PATH."catalog".DS."i".DS.$info->part_path.DS.$filename;
				else  $_dest=$info->full_path_dest.$info->part_path.DS.$filename;
				if(Files::isImage($_src))	{
					
					// источник есть и он картинка
					// при ресайзе создаем изображение
					
					
					$result=Files::resizeImage($_src, $_dest, $info->width, $info->height);
					//
					if (!$result){
						$report['result']=false;
						array_push($report['info'],$type_img." ".Text::_("not created"));
					}else{
						array_push($report['info'],$type_img." ".Text::_("is created"));
						// все создалось продолжаем преобразования
						// смотрим что с водяным знаком - это запускается один раз при создании нового
						// чтобы не дублировать водяные знаки бесконечно
						array_push($report['info'],$type_img." create WM ".(int)$info->applWM);
						if ($info->applWM) {
							$res_wm = $this->checkWM ( $_dest, $info->width, $info->height );
							array_push ( $report ['info'], $res_wm );
						}

						// смотрим что с webp преобразованием - после водяного знака чтобы сразу с ним преобразовать

						$thumb_img = $name_img;
						// файл $_dest создается в строке 547 , иначе мы сюда не попадаем
						if (catalogConfig::$webp_autocreate && ! Files::isExtImage ( $_dest, 'webp' )) { // надо создавать файл webp автоматом и у нас сам файл не является webp
							$res_webp = $this->checkWebp ( $_dest );
							if ($res_webp) {
								array_push ( $report ['info'], Text::_ ( 'Webp image created' ) );
								$thumb_img = $res_webp;
							} else {
								array_push ( $report ['info'], Text::_ ( 'Create webp image skipped' ) );
							}
						}
						$fileNameForSave=pathinfo($thumb_img, PATHINFO_BASENAME);
						if (!$fld_img) {
							if($info->table==='additional') 
								$result=$this->insertUpdateAdditionField('goods',$new_psid,$info->main_fld,$fileNameForSave);
								else $result=$this->updateFldGoods($new_psid,$info->main_fld,$fileNameForSave);
							
						}
						if (!$result){
							$report['result']=false;
							array_push($report['info'],$type_img." ".Text::_("update not succesful"));
						}else{
							array_push($report['info'],$type_img." ".Text::_("update base succesful")." ".$fileNameForSave);
						}
					}
				}else{
					array_push($report['info'],Text::_('Src not image'));
				}
			}
			else{
				array_push($report['info'],$type_img." ".Text::_("filled and file exists"));
			}
		} elseif ($info->autoresize && $info->width && $info->height && ( @$_FILES[$info->main_fld]["name"] || $imgFromBase)) {
			array_push($report['info'],$type_img." ".Text::_("In Resizing part"));
			// приведение к заданному размеру
			// преобразование к webp и наложение водяного знака в этой ветке не производится кроме g_images
			//$res=$this->getElement($new_psid);					if (!$res) return false;
			if(!$info->full_path_dest) $_dest=BARMAZ_UF_PATH."catalog".DS."i".DS.$info->part_path.DS.$filename;
			else $_dest=$info->full_path_dest.$info->part_path.DS.$filename;
					
				
			if ($fld_img && is_file($_dest)) {
				$_src=$_dest;
				if(Files::isImage($_src))	{
					// если у нас уже 
					if (!Files::resizeImage($_src, $_dest, $info->width, $info->height)) {
						$report['result']=false;
						array_push($report['info'],$type_img." ".Text::_("Change size not succesful"));
						
					}else{
						array_push($report['info'],$type_img." ".Text::_("Resizing succesful"));
					}
				}
			}
			// если у нас основная картинка g_image в первый раз то надо и к webp привести и на водяной знак проверить
			// причем на уже отресайзенную картинку
			if($type_img=="g_image")
			{
				array_push($report['info'],$type_img." create WM ".(int)$info->applWM);
				if ($info->applWM) {
					$res_wm = $this->checkWM ( $_dest, $info->width, $info->height );
					array_push ( $report ['info'], $res_wm );
				}
				
				// смотрим что с webp преобразованием - после водяного знака чтобы сразу с ним преобразовать
				
				$thumb_img = $name_img;
				// файл $_dest создается в строке 547 , иначе мы сюда не попадаем
				if (catalogConfig::$webp_autocreate && ! Files::isExtImage ( $_dest, 'webp' )) { // надо создавать файл webp автоматом и у нас сам файл не является webp
					$res_webp = $this->checkWebp ( $_dest );
					if ($res_webp) {
						array_push ( $report ['info'], Text::_ ( 'Webp image created' ) );
						$thumb_img = $res_webp;
					} else {
						array_push ( $report ['info'], Text::_ ( 'Create webp image skipped' ) );
					}
				}
				$fileNameForSave=pathinfo($thumb_img, PATHINFO_BASENAME);
				$result=$this->updateFldGoods($new_psid,$info->main_fld,$fileNameForSave);
				if (!$result){
					$report['result']=false;
					array_push($report['info'],$type_img." ".Text::_("update not succesful"));
				}else{
					array_push($report['info'],$type_img." ".Text::_("update base succesful")." ".$fileNameForSave);
				}
				
			}
			
			
		}
		return $report['result'];
	}
}
?>