<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//BARMAZ_MODULE_INFO

defined('_BARMAZ_VALID') or die("Access denied");

class catalogModelimages extends SpravModel {
	
	
	/*public function updateThumb($psid,$thumb){
		$sql="UPDATE #__goods_img SET i_thumb='".$thumb."' WHERE i_id='".$psid."'";
		$this->_db->setQuery($sql);
		return $this->_db->query();
	}
	*/
	public function updateFldGoods($psid,$fld,$content){
		$sql="UPDATE #__goods_img SET `".$fld."`='".$content."' WHERE i_id='".$psid."'";
		$this->_db->setQuery($sql);
		return $this->_db->query();
	}
	
	
	public function save()	{
		$mdl = Module::getInstance();
		$reestr = $mdl->get('reestr');
		$psid = $reestr->get('psid');
		$new_psid=parent::save();
		if ($new_psid) { 
			// операции только при создании нового товара
			// секция изображений основной товароной позиции
			// добавление функционала
			// наложение водяного знака
			// создание webp экземпляра
			$res=$this->getElement($new_psid);
			// нет данных по элементу - просто выходим			
			if (!$res) return false;
			// информатор по сохранению позиции
			$reestr->msg_img=array("result"=>true,"info"=>array());
			// первым делом отработаем источник изображений
			// источник всех изображений - главная картинка которую заливают - она есть только при апдейтах
			$filename=Files::splitAppendix($res->i_image, true);
			// если картинки нет - выходим
			//if (!$filename) return false;
			$result=$this->checkGoodsImg($new_psid,'i_image',$res->i_image,$res->i_image,$filename,$reestr->msg_img);
			$result=$this->checkGoodsImg($new_psid,'i_thumb',$res->i_image,$res->i_thumb,$filename,$reestr->msg_img);
			$result=$this->checkGoodsImg($new_psid,'i_med_image',$res->i_image,$res->i_med_image,$filename,$reestr->msg_img);
			// создание эскиза для слайдера
			// @TODO может стоит логгировать только при включенном дебаге делать равно как и формировать сам информаторий
			//  
			Util::logFile($reestr->msg_img,"Обработка доп изображений",false,false,'goods_img.log');
			// контроль размера основного изображения
		}		
		return $new_psid;
	}
	/**
	 * 
	 * @param string $fld_img  - имя поля теблицы - содержащее изображение
	 * @return boolean|stdClass
	 */
	public function getGoodsImgInfo($fld_img)
	{
		$info = new stdClass();
		switch($fld_img)
		{
			case 'i_thumb':
				$info->autocreate=catalogConfig::$thumbAutoCreate;
				$info->autoresize=catalogConfig::$thumbAutoResize;
				$info->width=catalogConfig::$thumb_width;
				$info->height=catalogConfig::$thumb_height;
				$info->applWM=catalogConfig::$thumbApplWM;
				$info->main_fld="i_thumb"; // поле cоздаваемого изображения
				$info->part_path="thumbs"; // часть пути
				$info->table='main';
				$info->quality=100;
				$info->full_path_dest=false;
				$info->check_img=array('prezent'=>0,'sizes'=>0,'webp'=>0,'watermark'=>0);
				$info->uploadPath=BARMAZ_UF_PATH.'catalog'.DS.'i'.DS.$info->part_path.DS;
				break;
			case 'i_med_image':
				$info->autocreate=catalogConfig::$mediumImgAutoCreate;
				$info->autoresize=catalogConfig::$mediumImgAutoResize;
				$info->width=catalogConfig::$mediumImgWidth;
				$info->height=catalogConfig::$mediumImgHeight;
				$info->applWM=catalogConfig::$mediumImgApplWM;
				$info->quality=100;
				$info->main_fld="i_med_image"; // поле cоздаваемого изображения
				$info->part_path="medium"; // часть пути
				$info->table='main';
				$info->full_path_dest=false;
				$info->check_img=array('prezent'=>0,'sizes'=>0,'webp'=>0,'watermark'=>0);
				$info->uploadPath=BARMAZ_UF_PATH.'catalog'.DS.'i'.DS.$info->part_path.DS;
				break;
			case 'i_image':
				$info->autocreate=false;
				$info->autoresize=catalogConfig::$MainImg_AutoResize;
				$info->width=catalogConfig::$MainImg_width;
				$info->height=catalogConfig::$MainImg_height;
				$info->applWM=catalogConfig::$MainImgApplWM;
				$info->quality=100;
				$info->main_fld="i_image"; // поле cоздаваемого изображения
				$info->part_path="fullsize"; // часть пути
				$info->table='main';// в какой таблице запись
				$info->full_path_dest=false; // есть ли полный путь к изображению
				$info->check_img=array('prezent'=>0,'sizes'=>0,'webp'=>0,'watermark'=>0);
				$info->uploadPath=BARMAZ_UF_PATH.'catalog'.DS.'i'.DS.$info->part_path.DS;
				break;
				
			default:
				return false;
				break;
		}
		
		return $info;
	}
	
	/**
	 * @todo - дублирование функции в модели изображений и товаров - нужен рефакторинг в этой части 
	 * наложение водяного знака на изображение
	 * водяной знак находится по пути PATH_WM  - PATH_IMAGES.'WM'
	 * в зависимости от необходимого размера
	 * файлы водяных знаков подготавливаются для проекта:
	 * формат прозрачный png
	 * имя файла wm_{width}_{height}.png
	 *
	 * @param string $dest - изображение на которое накладывается водяной знак
	 * @param int $width
	 * @param int $height
	 */
	public function checkWM($dest,$width,$height)
	{
		//$wm_file=PATH_WM."wm-".$width."-".$height.".png";
		// если водяного знака нет - выходим
		//var_dump($dest,$wm_file,is_file($wm_file));
		//if(!is_file($wm_file)) return $dest;		else
		return Files::addWaterMark($dest, "",$width,$height);
	}
	/**
	 * преобразование файла к webp
	 * @param string $dest - файл который преобразуем
	 */
	
	public function checkWebp($dest)
	{
		$res_create=false; // результат преобразования - логика 
		$res=Files::webpImage($dest,85,false,$res_create);
		if(!$res_create) return $dest; else return $res;
		
	}
	
	/**
	 * проверка состояния изображений товара
	 */
	public function testGoodsImg($new_psid,$type_img)
	{
		$info=$this->getGoodsImgInfo($type_img);
		if(!$info) return false;
	}
	/**
	 * проверка и создание дополнительных изображений к товару
	 * @param string $new_psid - ид записи
	 * @param string $type_img - тип изображения (thumb,medium_image,image,df_thumb_slider )
	 * @param string $filename - имя файла источника без путей
	 * @param string $name_img - имя файла изображения которое будет присвоено создаваемому
	 * @param string $fld_img - содержание поля создаваемого изображения(проверка на наличие)
	 * @param array $report  - массив с отладочной информацией
	 * 	 */
	public function checkGoodsImg($new_psid,$type_img,$name_img,$fld_img,$filename,&$report)
	{
		
		$info=$this->getGoodsImgInfo($type_img);
		if(!$info) return false;
		
		array_push($report['info'],$type_img." ".Text::_("Before check part"));
		
		// тут еще вариант когда у нас все данные уже в базе а не первичное сохранение
		// либо есть замена изображения
		$imgFromBase=false;
		
		if($type_img == 'image') {
			// проверяем основное изобюражение
			$condition=@$_FILES["i_image"]["name"];}
			else {
				// проверяем другое изображение
				$condition=@$_FILES["i_image"]["name"] && !@$_FILES[$main_fld]["name"];
			}
			
			if($condition===null){
				// у нас изображение основное и нет картинки на замену - просто работаем
				// с проверкой изображения в базе - приводим его к указанным в настройках показателям
				$imgFromBase=true;
			}
			if ($info->autocreate && $info->width && $info->height && $condition ) {
				if(!$info->full_path_dest){
					$_dest=BARMAZ_UF_PATH."catalog".DS."i".DS.$info->part_path.DS.$filename;
					$_dest_folder=BARMAZ_UF_PATH."catalog".DS."i".DS.$info->part_path.DS.Files::getAppendix($filename);
				}
				else{
					$_dest=$info->full_path_dest.$info->part_path.DS.$filename;
					$_dest_folder=$info->full_path_dest.$info->part_path.DS.Files::getAppendix($filename);
				}
				
				//var_dump($_dest,$fld_img,$filename,file_exists($_dest));
				if ((!$fld_img)||(!file_exists($_dest))) {
					// нет в таблице или нет самого файла и есть из чего создавать  - создаем
					// проверим путь назначения
					
					Files::checkFolder($_dest_folder, true);
					// источник изображения всегда главная картинка
					$_src=BARMAZ_UF_PATH."catalog".DS."i".DS."fullsize".DS.$filename;
					if(!$info->full_path_dest) $_dest=BARMAZ_UF_PATH."catalog".DS."i".DS.$info->part_path.DS.$filename;
					else  $_dest=$info->full_path_dest.$info->part_path.DS.$filename;
					if(Files::isImage($_src))	{
						
						// источник есть и он картинка
						// при ресайзе создаем изображение
						$result=Files::resizeImage($_src, $_dest, $info->width, $info->height);
						//
						if (!$result){
							$report['result']=false;
							array_push($report['info'],$type_img." ".Text::_("not created"));
						}else{
							array_push($report['info'],$type_img." ".Text::_("is created"));
							// все создалось продолжаем преобразования
							// смотрим что с водяным знаком - это запускается один раз при создании нового
							// чтобы не дублировать водяные знаки бесконечно
							array_push($report['info'],$type_img." create WM ".(int)$info->applWM);
							if ($info->applWM) {
								$res_wm = $this->checkWM ( $_dest, $info->width, $info->height );
								array_push ( $report ['info'], $res_wm );
							}
							
							// смотрим что с webp преобразованием - после водяного знака чтобы сразу с ним преобразовать
							
							$thumb_img = $name_img;
							// файл $_dest создается в строке 547 , иначе мы сюда не попадаем
							if (catalogConfig::$webp_autocreate && ! Files::isExtImage ( $_dest, 'webp' )) { // надо создавать файл webp автоматом и у нас сам файл не является webp
								$res_webp = $this->checkWebp ( $_dest );
								if ($res_webp) {
									array_push ( $report ['info'], Text::_ ( 'Webp image created' ) );
									$thumb_img = $res_webp;
								} else {
									array_push ( $report ['info'], Text::_ ( 'Create webp image skipped' ) );
								}
							}
							$fileNameForSave=pathinfo($thumb_img, PATHINFO_BASENAME);
							if (!$fld_img) {
								if($info->table==='additional')
									$result=$this->updateAdditionField('goods_img',$new_psid,$info->main_fld,$fileNameForSave);
									else $result=$this->updateFldGoods($new_psid,$info->main_fld,$fileNameForSave);
									
							}
							if (!$result){
								$report['result']=false;
								array_push($report['info'],$type_img." ".Text::_("update not succesful")." ".$this->_db->getQuery()."  ".$this->_db->getErrorMsg());
							}else{
								array_push($report['info'],$type_img." ".Text::_("update base succesful")." ".$fileNameForSave);
							}
						}
					}else{
						array_push($report['info'],Text::_('Src not image'));
					}
				}
				else{
					array_push($report['info'],$type_img." ".Text::_("filled and file exists"));
				}
			} elseif ($info->autoresize && $info->width && $info->height && ( @$_FILES[$info->main_fld]["name"] || $imgFromBase)) {
				array_push($report['info'],$type_img." ".Text::_("In Resizing part"));
				// приведение к заданному размеру
				// преобразование к webp и наложение водяного знака в этой ветке не производится кроме g_images
				//$res=$this->getElement($new_psid);					if (!$res) return false;
				if(!$info->full_path_dest) $_dest=BARMAZ_UF_PATH."catalog".DS."i".DS.$info->part_path.DS.$filename;
				else $_dest=$info->full_path_dest.$info->part_path.DS.$filename;
				
				
				if ($fld_img && is_file($_dest)) {
					$_src=$_dest;
					if(Files::isImage($_src))	{
						// если у нас уже
						if (!Files::resizeImage($_src, $_dest, $info->width, $info->height)) {
							$report['result']=false;
							array_push($report['info'],$type_img." ".Text::_("Change size not succesful"));
							
						}else{
							array_push($report['info'],$type_img." ".Text::_("Resizing succesful"));
						}
					}
				}
				// если у нас основная картинка g_image в первый раз то надо и к webp привести и на водяной знак проверить
				// причем на уже отресайзенную картинку
				if($type_img=="i_image")
				{
					array_push($report['info'],$type_img." create WM ".(int)$info->applWM);
					if ($info->applWM) {
						$res_wm = $this->checkWM ( $_dest, $info->width, $info->height );
						array_push ( $report ['info'], $res_wm );
					}
					
					// смотрим что с webp преобразованием - после водяного знака чтобы сразу с ним преобразовать
					
					$thumb_img = $name_img;
					// файл $_dest создается в строке 547 , иначе мы сюда не попадаем
					if (catalogConfig::$webp_autocreate && ! Files::isExtImage ( $_dest, 'webp' )) { // надо создавать файл webp автоматом и у нас сам файл не является webp
						$res_webp = $this->checkWebp ( $_dest );
						if ($res_webp) {
							array_push ( $report ['info'], Text::_ ( 'Webp image created' ) );
							$thumb_img = $res_webp;
						} else {
							array_push ( $report ['info'], Text::_ ( 'Create webp image skipped' ) );
						}
					}
					$fileNameForSave=pathinfo($thumb_img, PATHINFO_BASENAME);
					$result=$this->updateFldGoods($new_psid,$info->main_fld,$fileNameForSave);
					if (!$result){
						$report['result']=false;
						array_push($report['info'],$type_img." ".Text::_("update not succesful"));
					}else{
						array_push($report['info'],$type_img." ".Text::_("update base succesful")." ".$fileNameForSave);
					}
					
				}
				
				
			}
			return $report['result'];
	}
	
}
?>