<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : conf 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.0 (2023/04/04)
//  Build: 203 (2024-01-07 23:14:41)
// 


defined('_BARMAZ_VALID') or die("Access denied");

class defaultViewcpanel extends View {
	public $icons_arr = array();
	protected $disabled_modules = array();
	
	public function prepare(){
		foreach (Portal::getInstance()->getDisabledModules() as $d_module) {
			$this->disabled_modules[$d_module] = true;
		}
		$divider = 0;
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=user", "icon"=>"user.webp", "title"=>"Users", "class"=>"", "module"=>"user");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=aclmgr&view=roles", "icon"=>"roles.webp", "title"=>"Roles", "class"=>"", "module"=>"aclmgr");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=user&view=auth_providers", "icon"=>"user.webp", "title"=>"Auth providers", "class"=>"", "module"=>"user");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=conf&task=pi", "icon"=>"info.webp", "title"=>"System info", "class"=>"", "module"=>"conf");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=conf&view=config", "icon"=>"settings.webp", "title"=>"Settings", "class"=>"", "module"=>"conf");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=conf&view=modules", "icon"=>"modules.webp", "title"=>"Modules", "class"=>"", "module"=>"conf");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=conf&view=plugins", "icon"=>"plugins.webp", "title"=>"Plugins", "class"=>"", "module"=>"conf");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=conf&view=widgets", "icon"=>"widgets.webp", "title"=>"Widgets", "class"=>"", "module"=>"conf");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=conf&task=selectVisio", "icon"=>"prepare_visio.webp", "title"=>"Prepare visio", "class"=>"", "module"=>"conf");
		$divider++;
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=article", "icon"=>"articles.webp", "title"=>"Articles", "class"=>"", "module"=>"article");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=blog", "icon"=>"blogs.webp", "title"=>"Blogs", "class"=>"", "module"=>"blog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=acrm&view=items&layout=all", "icon"=>"acrm.webp", "title"=>"ACRM", "class"=>"", "module"=>"acrm");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=polls", "icon"=>"polls.webp", "title"=>"Polls", "class"=>"", "module"=>"polls");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=feedback", "icon"=>"feedback.webp", "title"=>"Feedback", "class"=>"", "module"=>"feedback");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=gallery", "icon"=>"gallery.webp", "title"=>"Gallery", "class"=>"", "module"=>"gallery");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=videoset", "icon"=>"video.webp", "title"=>"Video gallery", "class"=>"", "module"=>"videoset");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=comments", "icon"=>"comments.webp", "title"=>"Comments", "class"=>"", "module"=>"comments");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=forum", "icon"=>"forum.webp", "title"=>"Forum", "class"=>"", "module"=>"forum");
		$divider++;
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=orders", "icon"=>"orders.webp", "title"=>"Orders", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=goodsgroup", "icon"=>"goods.webp", "title"=>"Goods groups", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=options", "icon"=>"options.webp", "title"=>"Goods options", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=deliverytypes", "icon"=>"delivery.webp", "title"=>"Delivery types", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=paymenttypes", "icon"=>"payment.webp", "title"=>"Payment types", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=manufacturer_cats", "icon"=>"manufacturers.webp", "title"=>"Manufacturers", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=vendor_cats", "icon"=>"vendors.webp", "title"=>"Vendors", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=currency", "icon"=>"money.webp", "title"=>"Currencies", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=measures", "icon"=>"measures.webp", "title"=>"Measures", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=discounts", "icon"=>"discounts.webp", "title"=>"Discounts and surcharges", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=taxes", "icon"=>"taxes.webp", "title"=>"Taxes", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=import", "icon"=>"import.webp", "title"=>"Import catalog data", "class"=>"", "module"=>"catalog");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=catalog&view=export", "icon"=>"export.webp", "title"=>"Export catalog data", "class"=>"", "module"=>"catalog");
		$divider++;
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=service&view=db", "icon"=>"backup.webp", "title"=>"Backup tables", "class"=>"", "module"=>"service");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=service&view=cachemanager", "icon"=>"cache.webp", "title"=>"Cache manager", "class"=>"", "module"=>"service");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=service&task=startMediamanager", "icon"=>"files.webp", "title"=>"Media manager", "class"=>"relpopupwt", "module"=>"service");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=installer", "icon"=>"installer.webp", "title"=>"Installer", "class"=>"", "module"=>"installer");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=service&view=updater", "icon"=>"updates.webp", "title"=>"Check for updates", "class"=>"", "module"=>"service");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=help", "icon"=>"help.webp", "title"=>"Help", "class"=>"", "module"=>"help");
		$this->icons_arr[$divider][] = array("link"=>"index.php?module=help&layout=license", "icon"=>"license.webp", "title"=>"License", "class"=>"", "module"=>"help");
		$this->icons_arr[$divider][] = array("link"=>Portal::getInstance()->getURI(1)."index.php?option=logout", "icon"=>"exit.webp", "title"=>"Logout", "class"=>"", "module"=>"");
		Event::raise("admin.conf.cpanel.data.prepared", array(), $this->icons_arr);
	}
}
?>