<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : service 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.1 (2023/09/29)
//  Build: 203 (2024-01-07 23:14:41)
// 


defined('_BARMAZ_VALID') or die("Access denied");

class serviceModelimageprocessor extends Model {
	private $_hiddenfiles=array('.','.svn','resources','index.php','index.html','.htaccess','.htpasswd','web.config');
	public function getImageFields(){
		$res=array();
		// в целом может имеет смысл сделать метод внутри модулей , который возвращает свои ресурсы, подлежащие обработке
		// но пока сложим тут 
		// статьи 
		$res[]=array("module"=>"article","type"=>"file","view"=>"items", "layout"=>"defl", "field"=>"a_thumb", "source"=>"a_thumb", "width"=>$this->getModule()->getController()->getConfigVal("thumb_width"), "height"=>$this->getModule()->getController()->getConfigVal("thumb_height"), "checkACL"=>"viewArticleItems");
		$res[]=array("module"=>"article","type"=>"text","view"=>"items", "layout"=>"defl", "field"=>"a_text", "source"=>"a_thumb", "width"=>false, "height"=>false, "checkACL"=>"viewArticleItems");
		// блоги
		$res[]=array("module"=>"blog","type"=>"file","view"=>"post", "layout"=>"defl", "field"=>"p_thumb", "source"=>"p_thumb", "width"=>$this->getModule()->getController()->getConfigVal("thumb_width"), "height"=>$this->getModule()->getController()->getConfigVal("thumb_height"), "checkACL"=>"viewBlogPost");
		$res[]=array("module"=>"blog","type"=>"text","view"=>"post", "layout"=>"defl", "field"=>"p_text", "source"=>"p_text", "width"=>false, "height"=>false, "checkACL"=>"viewBlogPost");
    // каталог 		
		$res[]=array("module"=>"catalog","type"=>"file","view"=>"goodsgroup", "layout"=>"defl", "field"=>"ggr_thumb", "source"=>false, "width"=>catalogConfig::$ggr_thumb_width, "height"=>catalogConfig::$ggr_thumb_height, "checkACL"=>"viewCatalogGoodsgroup");
		$res[]=array("module"=>"catalog","type"=>"file","view"=>"goods", "layout"=>"defl", "field"=>"g_image", "source"=>"g_image", "width"=>false, "height"=>false, "checkACL"=>"viewCatalogGoods");
		$res[]=array("module"=>"catalog","type"=>"file","view"=>"goods", "layout"=>"defl", "field"=>"g_medium_image", "source"=>"g_image", "width"=>catalogConfig::$mediumImgWidth, "height"=>catalogConfig::$mediumImgHeight, "checkACL"=>"viewCatalogGoods");
		$res[]=array("module"=>"catalog","type"=>"file","view"=>"goods", "layout"=>"defl", "field"=>"g_thumb", "source"=>"g_image", "width"=>catalogConfig::$thumb_width, "height"=>catalogConfig::$thumb_height, "checkACL"=>"viewCatalogGoods");
		$res[]=array("module"=>"catalog","type"=>"file","view"=>"images", "layout"=>"defl", "field"=>"i_thumb", "source"=>"i_image", "width"=>catalogConfig::$thumb_width, "height"=>catalogConfig::$thumb_height, "checkACL"=>"viewCatalogGoods");
		// галерея
		$res[]=array("module"=>"gallery","type"=>"file","view"=>"groups", "layout"=>"defl", "field"=>"gr_thumb", "source"=>"gr_thumb", "width"=>galleryConfig::$ggr_thumbWidth, "height"=>galleryConfig::$ggr_thumbHeight, "checkACL"=>"viewGalleryGroups");
		$res[]=array("module"=>"gallery","type"=>"file","view"=>"items", "layout"=>"defl", "field"=>"g_thumb", "source"=>"g_thumb", "width"=>galleryConfig::$gal_thumbWidth, "height"=>galleryConfig::$gal_thumbHeight, "checkACL"=>"viewGalleryItems");
		$res[]=array("module"=>"gallery","type"=>"file","view"=>"images", "layout"=>"defl", "field"=>"gi_thumb", "source"=>"gi_image", "width"=>galleryConfig::$thumbWidth, "height"=>galleryConfig::$thumbHeight, "checkACL"=>"viewGalleryImages");
		$res[]=array("module"=>"gallery","type"=>"file","view"=>"images", "layout"=>"defl", "field"=>"gi_image", "source"=>"gi_image", "width"=>false, "height"=>false, "checkACL"=>"viewGalleryImages");
		// просто папка на диске -используем в шаблонах, каких то внешних возможностях
		$res[]=array("module"=>"service","type"=>"file","view"=>"folders", "layout"=>"defl", "field"=>"", "source"=>"", "width"=>false, "height"=>false, "checkACL"=>"useImageProcessor");
		return $res;
	}
	/**
	 * Получаем объект по полному ключу
	 * $key=$field_array["module"]."#".$field_array["view"]."#".$field_array["layout"]."#".$field_array["field"];   
	 * @param string $key
	 * @return objects|boolean
	 */
	public function getImageObject($key){
		$objects = $this->getImageObjects();
		if(array_key_exists($key, $objects)) return $objects[$key];
		else return false;
	}
	/**
	 * Получаем объект по короткому  ключу
	 * $key=$field_array["module"]."_".$field_array["view"];
	 * внутри все нужные поля для преобразований
	 * @param string $key
	 * @return object|boolean
	 */
	
	public function getImageObjectByModule($key){
		$objects = $this->getImageObjects();
		$object_pr=array();
		$sep_search_key=explode("_",$key);
		foreach($objects as $ko=>$vo)
		{
			$sep_obj_key=explode("#",$ko);
			if($sep_search_key[0]==$sep_obj_key[0]&&$sep_search_key[1]==$sep_obj_key[1])
			{
				// нужный нам объект
				$object_pr[$sep_obj_key[3]]=$vo;
			}
			
		}  
		if(count($object_pr)>0) return $object_pr;
		else return false;
	}
	
	public function getImageObjects(){
		$image_fields=$this->getImageFields();
		$images=array();
		foreach($image_fields as $k=>$field_array){
			//вставляем сюда обработку папок вне системы метадат по модулю service
			if($field_array["module"]=='service'){
				$key=$field_array["module"]."#".$field_array["view"]."#"."webp"."#"."folder_name";
				$images[$key]["checkACL"]=$field_array["checkACL"];
				$images[$key]["field_title"]=Text::_("Folder");
				$images[$key]["field_name"]=false;
				$images[$key]["keystring"]=false;
				$images[$key]["namestring"]=false;
				$images[$key]["multy_field"]=false;
				$images[$key]["deleted"]=false;
				$images[$key]["enabled"]=false;
				$images[$key]["module"]=false;
				$images[$key]["type"]=$field_array["type"];
				$images[$key]["view"]=false;
				$images[$key]["width"]=false;
				$images[$key]["height"]=false;
				$images[$key]["layout"]=false;
				$images[$key]["title"]=Text::_("Creating images in a folder");
				$images[$key]["tablename"]=false;
				
				
			}else{
			Text::parseModule($field_array["module"]);
			$key=$field_array["module"]."#".$field_array["view"]."#".$field_array["layout"]."#".$field_array["field"];
			$meta = new SpravMetadata($field_array["module"], $field_array["view"], $field_array["layout"], true, true, 0);
			//Util::showArray($meta);
			$field_index=-1;
			foreach($meta->field as $kf=>$kv){
				if($kv==$field_array["field"]){
					$field_index=$kf;
				}
			}
			if($field_index>-1){
				if (ACLObject::getInstance($field_array["checkACL"], false)->canAccess()){
					$images[$key]["checkACL"]=$field_array["checkACL"];
					$images[$key]["field_title"]=Text::_($meta->field_title[$field_index]);
					$images[$key]["field_name"]=$field_array["field"];
					$images[$key]["keystring"]=$meta->keystring;
					$images[$key]["namestring"]=$meta->namestring;
					$images[$key]["multy_field"]=$meta->multy_field;
					$images[$key]["linktable"]=$meta->linktable;
					$images[$key]["parenttable"]=$meta->parent_table;
					$images[$key]["deleted"]=$meta->deleted;
					$images[$key]["enabled"]=$meta->enabled;
					$images[$key]["module"]=$meta->module;
					$images[$key]["type"]=$field_array["type"];
					$images[$key]["view"]=$field_array["view"];
					$images[$key]["width"]=$field_array["width"];
					$images[$key]["height"]=$field_array["height"];
					$images[$key]["layout"]=$field_array["layout"];
					$images[$key]["title"]=Text::_($meta->module).": ".Text::_($meta->title);
					$images[$key]["tablename"]=$meta->tablename;
					$images[$key]["dest_path"]=$path = str_replace("/", DS, BARMAZ_UF_PATH.$meta->module.DS.$meta->upload_path[$field_index]).DS;
					if($field_array["source"] && $field_array["source"] != $field_array["field"]){
						$images[$key]["source_field_name"]=$field_array["source"];
						$field_index=-1;
						foreach($meta->field as $kf=>$kv){
							if($kv==$field_array["source"]){
								$field_index=$kf;
							}
						}
						if($field_index>-1){
							$images[$key]["source_path"]=str_replace("/", DS, BARMAZ_UF_PATH.$meta->module.DS.$meta->upload_path[$field_index]).DS;
						} else {
							unset($images[$key]);
						}
					} else {
						$images[$key]["source_field_name"]=false;
						$images[$key]["source_path"]=false;
					}
				}
			}
			unset($meta);
		}
		}
		return $images;
	}
	
	public function getTotalRecords($image_object, $enabled_only, $skip_deleted) {
		$sql = "SELECT COUNT('".$image_object["keystring"]."') FROM #__".$image_object["tablename"];
		if($enabled_only || $skip_deleted){
			$where_sql="";
			if($enabled_only) $where_sql.=($where_sql ? " AND " : " ").$image_object["enabled"]."=1";
			if($skip_deleted) $where_sql.=($where_sql ? " AND " : " ").$image_object["deleted"]."=0";
			$sql.=($where_sql ? " WHERE".$where_sql : "");
		}
		$this->_db->setquery($sql);
		return $this->_db->loadResult();
	}
	/**
	 * получаем список записей с учетом входящих ограничений
	 * @param array $image_object
	 * @param bool $enabled_only
	 * @param bool $skip_deleted
	 * @param bool|string $where_select 
	 * @return NULL|int
	 */
	public function getTotalRecordsForModule($image_object, $enabled_only, $skip_deleted,$where_select=false) {		
		$sql = "SELECT COUNT('".$image_object["keystring"]."') FROM #__".$image_object["tablename"]." AS c";
		if($where_select){
			// добавим join
		$sql.=" LEFT JOIN #__".$image_object["linktable"]." AS links ON links.".$image_object["multy_field"]."=c.".$image_object["multy_field"]."\n";
			
		}
		
		if($enabled_only || $skip_deleted ||$where_select){
			$where_sql="";
			if($enabled_only)  $where_sql.=($where_sql ? " AND " : " ")."c.".$image_object["enabled"]."=1";
			if($skip_deleted)  $where_sql.=($where_sql ? " AND " : " ")."c.".$image_object["deleted"]."=0";
			if($where_select)  {
				//$where_sql_txt.=" AND links.parent_id='".$image_object["multy_field"]."' ";
				//$where_sql.=($where_sql ? " AND " : " ").$image_object["multy_field"]."=".(int)$where_select. " OR ".$image_object["keystring"]."=".(int)$where_select;
				// но это только вложенные именно в эту группу позиции заберет , вниз по группам он не бежит
				// это надо видимо тут решать через in
				$where_sql.=($where_sql ? " AND " : " ")." links.parent_id='".$where_select."' ";
			
			}
			$sql.=($where_sql ? " WHERE".$where_sql : "");
		}		
		$this->_db->setquery($sql);
		//Util::logFile($this->_db->getQuery());
		//echo $this->_db->getQuery();
		return $this->_db->loadResult();
	}
	
	public function resizeRecords($image_object, $start, $records_per_pass, $enabled_only, $skip_deleted, $force_from_source){
		$result=array();
		$sql = "SELECT ".$image_object["keystring"]." AS ind, ".$image_object["namestring"]." AS title, ".($image_object["source_field_name"] ? $image_object["source_field_name"] : "''")." AS src, ".$image_object["field_name"]." AS dest FROM #__".$image_object["tablename"];
		if($enabled_only || $skip_deleted){
			$where_sql="";
			if($enabled_only) $where_sql.=($where_sql ? " AND " : " ").$image_object["enabled"]."=1";
			if($skip_deleted) $where_sql.=($where_sql ? " AND " : " ").$image_object["deleted"]."=0";
			$sql.=($where_sql ? " WHERE".$where_sql : "");
		}
		$sql.=" ORDER BY ".$image_object["keystring"]." LIMIT ".($start-1).", ".$records_per_pass;
		$this->_db->setquery($sql);
//		Util::logFile($sql);
		$records = $this->_db->loadObjectList('ind');
		if(count($records)){
			foreach($records AS $id=>$rec){
				$error=false;
				$src_file=""; $dest_file=""; $dest_filename="";
				if($rec->dest){ // есть имя файла назначения
					$dest_file = $image_object['dest_path'].Files::splitAppendix($rec->dest, true);
					if(is_file($dest_file) && !$force_from_source ){ // есть файл назначения, перегенерация не нужна, значит он же файл источника
						$src_file=$dest_file;
					} elseif(is_file($dest_file) && $force_from_source){ // есть файл назначения, нужна перегенерация
						/************************************************************/
						if($rec->src) { // есть имя источника
							$src_file = $image_object['source_path'].Files::splitAppendix($rec->src, true);
							if(!is_file($src_file)){ // нет файла источника
								$error = true;
								$error_message="[ID#".$rec->ind."] ".$rec->title.": ".Text::_("Source file absent").": ".$src_file.", ".Text::_("Destination file present").": ".$dest_file;
							}
						} else {
							$error = true;
							$error_message="[ID#".$rec->ind."] ".$rec->title.": ".Text::_("Destination file present").": ".$dest_file.", ".Text::_("Source filename absent");
						}
						/************************************************************/
					} elseif($rec->src) { // нет файла назначения, есть имя источника
						$src_file = $image_object['source_path'].Files::splitAppendix($rec->src, true);
						if(!is_file($src_file)){ // нет файла источника
							$error = true;
							$error_message="[ID#".$rec->ind."] ".$rec->title.": ".Text::_("Source file absent").": ".$src_file.", ".Text::_("Destination file absent").": ".$dest_file;
						} else {
							$dest_filename=$rec->src;
							$dest_file = $image_object['dest_path'].Files::splitAppendix($dest_filename, true);
							if(is_file($dest_file)){ // уже есть такой файл назначения, генерируем новое имя
								$rash=strrchr(strval($dest_filename), '.'); //забираем раширение файла
								$dest_filename=md5(time().$rec->ind.$image_object['module'].$dest_filename).time().$rash;
								Files::checkFolder($image_object['dest_path'].Files::getAppendix($dest_filename, true), true);
								$dest_file = $image_object['dest_path'].Files::splitAppendix($dest_filename, true);
							}
						}
					} else {
						$error = true;
						$error_message="[ID#".$rec->ind."] ".$rec->title.": ".Text::_("Destination file absent").": ".$dest_file.", ".Text::_("Source filename absent");
					}
				} elseif($rec->src){ // есть имя файла источника, нет имени файла назначения
					$src_file = $image_object['source_path'].Files::splitAppendix($rec->src, true);
					if(!is_file($src_file)){ // нет файла источника
						$error = true;
						$error_message="[ID#".$rec->ind."] ".$rec->title.": ".Text::_("Source file absent").": ".$src_file.", ".Text::_("Destination filename absent").": ".$dest_file;
					} else {
						$dest_filename=$rec->src;
						$dest_file = $image_object['dest_path'].Files::splitAppendix($dest_filename, true);
						if(is_file($dest_file)){ // уже есть такой файл назначения, генерируем новое имя
							$rash=strrchr(strval($dest_filename), '.'); //забираем раширение файла
							$dest_filename=md5(time().$rec->ind.$image_object['module'].$dest_filename).time().$rash;
							Files::checkFolder($image_object['dest_path'].Files::getAppendix($dest_filename, true), true);
							$dest_file = $image_object['dest_path'].Files::splitAppendix($dest_filename, true);
						}
					}
				} else {
					// нет имени файла источника, нет имени файла назначения
					$error = true;
					$error_message="[ID#".$rec->ind."] ".$rec->title.": ".Text::_("Source and destinatinations filenames absent");
				}
				if(!$error){
					if($src_file && $dest_file){ // все нормально, делаем ресайз
						$resize_result=@Files::resizeImage($src_file, $dest_file, $image_object["width"], $image_object["height"]);
//						Util::logFile("[ID#".$rec->ind."] ".$rec->title.": ".$src_file."=>".$dest_file."=>".$image_object["width"]."=>".$image_object["height"]);
						if($resize_result){
							if($dest_filename){ // апдейтим поле в базе
								$sql="UPDATE #__".$image_object["tablename"]." SET ".$image_object["field_name"]."='".$dest_filename."' WHERE ".$image_object["keystring"]."=".$rec->ind;
								$this->_db->setQuery($sql);
								if($this->_db->query()){
									// EVERYTHING OK
								} else { // не удалось обновить поле в базе
									$error = true;
									$error_message="[ID#".$rec->ind."] ".$rec->title.": ".Text::_("Failed updating database")." (".$dest_filename.")";
									if(is_file($dest_file)) Files::delete($dest_file, true);
								}
							} else {
								// EVERYTHING OK
							}
						} else {
							$error = true;
							$error_message="[ID#".$rec->ind."] ".$rec->title.": ".Text::_("Failed resizing file").": ".$src_file." => ".$dest_file;
						}
					}
				}
				if($error){
					$result[$rec->ind]["status"]="ERROR";
					$result[$rec->ind]["message"]=$error_message;
				} else {
					$result[$rec->ind]["status"]="OK";
					$result[$rec->ind]["message"]="";
				}
			}
		}
		return $result;
	}
	
	public static function webpImage($source, $quality = 100, $removeOld = false)
	{
		$dir = pathinfo($source, PATHINFO_DIRNAME);
		$name = pathinfo($source, PATHINFO_FILENAME);
		$destination = $dir . DIRECTORY_SEPARATOR . $name . '.webp';
		$info = getimagesize($source);
		$isAlpha = false;
		if ($info['mime'] == 'image/jpeg')
			$image = imagecreatefromjpeg($source);
		elseif ($isAlpha = $info['mime'] == 'image/gif') {
				$image = imagecreatefromgif($source);
			} 
		elseif ($isAlpha = $info['mime'] == 'image/png') {
				$image = imagecreatefrompng($source);
			} 
		else {
				return $source;
			}
		if ($isAlpha) {
			imagepalettetotruecolor($image);
			imagealphablending($image, true);
			imagesavealpha($image, true);
		}
		imagewebp($image, $destination, $quality);
		/* костыль если будет не валиджный - просто сложу его
		 * $fpr=fopen($destination, "a+");
			fwrite($fpr, chr(0x00));
			fclose($fpr);
		 * 
		 * */
		
		
		if ($removeOld)	unlink($source);
		return $destination;
	}
	
	/**
	 * обработка записи по генерации webp файлов
	 * @param array $image_object_all - объект для формирования запроса
	 * @param int $start - начальная позиция (в лимите)
	 * @param int $records_per_pass - ограничение лимита выборки
	 * @param bool $enabled_only - только включенные
	 * @param bool $skip_deleted - пропускать удаленные
	 * @param bool $force_from_source  - принудительная генерация (атавизм, хотя может стоит использовать для пересоздания)
	 * @param int $where_select - значение поля multy_field для записей. Ограничение выборки (родительская группа и т.п.) 
	 * @return array|string
	 */
	public function webpRecords($image_object_all, $start, $records_per_pass, $enabled_only, $skip_deleted, $force_from_source,$where_select){
		$result = array ();
		// основной объект
		$image_object = $image_object_all ["main"];
		$fields_object = $image_object_all ["fld"];
		$proc_quality = 85; // процент качества пересжатия в webp 
		//Util::logFile($fields_object);
		//Util::logFile(Util::traceStack());
		//Util::showArray($fields_object,'fields_object');
		// массив задействованных полей с типами
		$arr_fld = array ();
		$sql = "SELECT c." . $image_object ["keystring"] . " AS ind, c." . $image_object ["namestring"] . " AS title ";
		// тут у нас несколько полей может быть. поля как ключи объекта

		foreach ( $fields_object as $kf => $vf ) {
			$sql .= "," . ($vf ["source_field_name"] ? "c.".$vf ["source_field_name"] : "''") . " AS " . $kf . "_src, 
			 c." . $vf ["field_name"] . " AS " . $kf . "_dest ";
			$arr_fld [$kf] = $vf["type"];
		}

		$sql .= " FROM #__" . $image_object ["tablename"]." as c " ;
		if($where_select){
			if($where_select){
				// добавим join
				$sql.=" LEFT JOIN #__".$image_object["linktable"]." AS links ON links.".$image_object["multy_field"]."=c.".$image_object["multy_field"]."\n";
				
			}
			
		}
		
		if ($enabled_only || $skip_deleted || $where_select) {
			$where_sql = "";
			if ($enabled_only)
				$where_sql .= ($where_sql ? " AND " : " ") . "c.".$image_object ["enabled"] . "=1";
			if ($skip_deleted)
				$where_sql .= ($where_sql ? " AND " : " ") . "c.".$image_object ["deleted"] . "=0";			
			if($where_select) 
				$where_sql.=($where_sql ? " AND " : " ")." links.parent_id='".$where_select."' ";
				//$where_sql.=($where_sql ? " AND " : " ").$image_object["multy_field"]."=".(int)$where_select. " OR ".$image_object["keystring"]."=".(int)$where_select;
			$sql .= ($where_sql ? " WHERE" . $where_sql : "");
			
		}
		
		// тут добавляем к запросу ограничение выборки на указанное поле или группу				
		

		$sql .= " ORDER BY c." . $image_object ["keystring"] . " LIMIT " . ($start - 1) . ", " . $records_per_pass;
		$this->_db->setquery ( $sql );
		//Util::logFile('zapros webcreate : '.$this->_db->getQuery ());
		//Util::logFile($arr_fld);
		$records = $this->_db->loadObjectList ( 'ind' );		
		if (is_array($records) && count ( $records )) {
			foreach ( $records as $id => $rec ) {
				$error = false;
				// тут у нас снова несколько полей - цикл по ним
				$upd_fld_str='';
				foreach ( $arr_fld as $ka => $va ) {
					$dest = $ka . "_dest";
					$src = $ka . "_src";
					
					switch ($va) {

						case "file" :
							// если у нас тип файл - все просто в поле живет файл
							$src_file = "";
							$dest_file = "";
							$dest_filename = "";
							//Util::logFile('dest:'.$dest." ".$rec->$dest);
							// можем что-то делать только если есть с чем работать
							// вариант только один есть что делать - если получается 
							// генерируем webp  
							if ($rec->$dest) { // есть имя файла назначения
								$dest_file = $fields_object[$ka] ['dest_path'] . Files::splitAppendix ( $rec->$dest, true );
								//Util::logFile('dest_file do:'.$dest_file);
								//var_dump($dest_file);
								if (is_file ( $dest_file ) && ! $force_from_source) { // есть файл назначения, перегенерация не нужна, значит он же файл источника
									//Util::logFile('dest_file: '.$dest_file." ".$rec->$dest);
									// тут смотрим его расширение и если это не webp
									// пишем новое название файла
									$res_crWebp=Files::webpImage($dest_file);
									$posW=strpos($res_crWebp,'webp');
									//var_dump($posW,$res_crWebp);
									//Util::logFile('res_crWebp: '.$res_crWebp);
									if($posW!==false&&$res_crWebp!=$dest_file)
									{										
										// у нас создался webp, нужно апдейтить таблицу
										$src_file= pathinfo($res_crWebp,PATHINFO_BASENAME);
										$upd_fld_str.=($upd_fld_str ? " , " : " ") .$fields_object[$ka]["field_name"] . "='" . $src_file . "'";
									}
									//$src_file = $dest_file;
								} elseif (is_file ( $dest_file ) && $force_from_source) { // есть файл назначения, нужна перегенерация
									/**
									 * *********************************************************
									 */
									if ($rec->$src) { // есть имя источника
										$src_file = $image_object ['source_path'] . Files::splitAppendix ( $rec->$src, true );
										if (! is_file ( $src_file )) { // нет файла источника
											$error = true;
											$error_message = "[ID#" . $rec->ind . "] " . $rec->title . ": " . Text::_ ( "Source file absent" ) . ": " . $src_file . ", " . Text::_ ( "Destination file present" ) . ": " . $dest_file;
										}
									} else {
										$error = true;
										$error_message = "[ID#" . $rec->ind . "] " . $rec->title . ": " . Text::_ ( "Destination file present" ) . ": " . $dest_file . ", " . Text::_ ( "Source filename absent" );
									}
								/**
								 * *********************************************************
								 */
								}
								else {
									$error = true;
									$error_message = "[ID#" . $rec->ind . "] " . $rec->title . ": " . Text::_ ( "Destination file absent" ) . ": " . $dest_file . ", " . Text::_ ( "Source filename absent" );
								}
							} else {
								// нет имени файла источника, нет имени файла назначения
								$error = true;
								$error_message = "[ID#" . $rec->ind . "] " . $rec->title . ": " . Text::_ ( "Source and destinatinations filenames absent" );
							}
							break;

						case 'text' : // тут у нас верстка - надо доставать все изображения что тут есть

							  $need_upd=false; 								
							  $result_t = array(); 
							  // с помощью регулярного выражения из $rec->$src мы получаем массив путей $result
							  preg_match_all('/<img[^>]*?src=\"(.*)\"/iU', $rec->$dest, $result_t);
								// у нас два масссива
								// в 0 живут тайтлы
								// в 1 живут пути к картинкам						
								// смотрим на наличие элементов массива изображений
							  if(count($result_t[1])>0)
								{
									foreach($result_t[1] as $img)
									{
										// пути уже организованы по принципу полного пути
										// /userfiles/novosti/otkrytie_avtogorodka_dou2649_2.webp
										// получаем путь к файлу
										$file_img=PATH_FRONT.str_replace("/", DS, $img);
										$file_img = str_replace(DS.DS,DS,$file_img);
										
										if (is_file( $file_img ) && ! $force_from_source) { // есть файл назначения, перегенерация не нужна, значит он же файл источника
											// тут смотрим его расширение и если это не webp
											$ext_img= pathinfo($file_img,PATHINFO_EXTENSION);
											if(Files::isImage($file_img)){
												if($ext_img=='webp') continue; // пропускаем внутренний цикл у нас уже webp
												// преобразовываем его в webp
												$res_crWebp=Files::webpImage($file_img,$proc_quality);
												// Если создание состоялось то формируем подмену
												if($res_crWebp){
													$new_fimg=substr($img,0,strrpos($img,".")).".webp";
													//меняем в тексте
													$rec->$dest = str_replace($img,$new_fimg,$rec->$dest);
													// есть чего менять в текстовом поле
													$need_upd=true;													
												}
											}											
										}
									}
								}
								if($need_upd){
								
									$upd_fld_str.=($upd_fld_str ? " , " : " ") .$fields_object[$ka]["field_name"] . "='" . $rec->$dest . "'";
								}
								/* 
								if (isset($result[1][0])) // если не пусто, то выводим картинку
								{
    								$item->img = '<img src="'.$result[1][0].'" alt="'.$item->title.'" />';
								}*/
							
							
							break;
					}
				} // конец цикла по полям в записи

				// тут  апдейтим запись таблицы
				//Util::logFile($error,'Ошибки До апдейта');
				if (! $error) {
					// возможно тут понадобятся еще какие то условия
					if($upd_fld_str){
						$sql = "UPDATE #__" . $image_object ["tablename"] . " SET ";
						$sql.=$upd_fld_str;						
						$sql.= " WHERE " . $image_object ["keystring"] . "=" . $rec->ind;
					$this->_db->setQuery ( $sql );
					//Util::logFile('zapros update : '.$this->_db->getQuery ());
					if ($this->_db->query ()) {
						// EVERYTHING OK
					} else { // не удалось обновить поле в базе
						$error = true;
						$error_message = "[ID#" . $rec->ind . "] " . $rec->title . ": " . Text::_ ( "Failed updating database" ) . " (" . $upd_fld_str . ")";
						// это конечно очистка - но торопиться с удалением не надо 
						//if (is_file ( $dest_file )) Files::delete ( $dest_file, true );
					}
					
					} // есть строчка апдейта полей
				} // нет ошибок
				
				//Util::logFile($error,'Ошибки После запроса');
				if ($error) {
					$result [$rec->ind] ["status"] = "ERROR";
					$result [$rec->ind] ["message"] = $error_message;
				} else {
					$result [$rec->ind] ["status"] = "OK";
					$result [$rec->ind] ["message"] = "";
				}
			}
		}
		return $result;
	}
	// функции по модулям , может имеет смысл их разнести по разным модулям, но пока тут
	/**
	 * Список основных изображений по товару  
	 * @param int $id - ид товара
	 */
	public function getMainImgListByGoods($id)
	{
		$this->_db->setQuery('select g_name, g_id, g_image,g_medium_image,g_thumb from #__goods where g_id='.(int)$id);
		$res=false;
		$this->_db->loadObject($res);
		$list_img=array();
		if($res)
		{
			$list_img['g_image']=$res->g_image;
			$list_img['g_thumb']=$res->g_thumb;
			$list_img['g_medium_image']=$res->g_medium_image;
			return $list_img;
		}
		return false;
	}
	/**
	 * Список  дополнительных изображений по товару
	 * @param int $id - ид изображения
	 */
	public function getMainImgListByImages($id)
	{
		$this->_db->setQuery('select i_title, i_id, i_image,i_med_image,i_thumb from #__goods_img where i_id='.(int)$id);
		$res=false;
		$this->_db->loadObject($res);
		$list_img=array();
		if($res)
		{
			$list_img['i_image']=$res->i_image;
			$list_img['i_thumb']=$res->i_thumb;
			$list_img['i_med_image']=$res->i_med_image;
			return $list_img;
		}
		return false;
	}
	
	
	/**
	 * преобразование  webp 
	 * @param string $service_folders - папка от которой ищем и преобразовываем images
	 * @param int $service_folders_all
	 * на возврате  массив status  
	 */
	public function createWebpToFolders($service_folders,$service_folders_all)
	{
		// получаем список файлов в директории
		$listFiles=array();
		$countFiles=0;
		$typesarray=array("gif","jpg","jpeg","png");
		$resGetFiles=Files::getFolderContentByType($service_folders,"", $typesarray, true, $listFiles, $countFiles);
		// тут у нас может появится список файлов которые мы приводим к нужному виду.
		$mess=Text::_("Result conversion :")."< br/>";
		foreach($listFiles as $file)
		{
			// если это директория - пропускаем
			if($file["folder"]==1) continue;
			// если это файл изображения то делаем для него дубль webp
			// еще нужно посмтреть выигрыш в объеме
			$source=$service_folders.DS.$file["subpath"].DS.$file["filename"];
			$res_create=false;
			$webp_create=Files::webpImage($source,75,false,$res_create);
			if($res_create)
			{
				$mess.=$webp_create.' create OK< br/>';
			}else{
				$mess.=$webp_create.' create ERROR< br/>';
			}
		}
		$status ["status"] = "finished";
		$status ["message"] = $mess;
		return $status;
		//Util::showArray($listFiles);
	}
	
	
}
?>