<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : service 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.1 (2023/09/29)
//  Build: 203 (2024-01-07 23:14:41)
// 

defined('_BARMAZ_VALID') or die("Access denied");?>

<?php
$script="
function massResizeOnSubmit(){
	if($('#i_understand_1').prop('checked')) return true;
	else return false;
}
function massOptimizeOnSubmit(){
	if($('#i_understand_2').prop('checked')) return true;
	else return false;
}
function massWebpOnSubmit(){
    $('#w_i_understand').labels().removeClass(\"invalid\");
	if($('#w_i_understand').prop('checked')){
 		return true;
	}
	else {
	$('#w_i_understand').labels().addClass(\"invalid\");
	return false;
	}
}
function setFoldersWebp(el){
   console.log($(el).val());
}
function setWebpProc(el){
   console.log($(el).val());
	ajaxShowActivity();
	$.ajax({
		url : siteConfig['siteUrl'] + \"index.php\",
		data : ({
			type : 'module',
			option : 'ajax',
			lim : $(el).val(),
			module : 'service',
			view : 'imageprocessor',			
			task : 'setSelectField'
		}),
		dataType : 'html',
		success : function(data, textStatus) {
         $(\"div#select_list_fld\").html(data);
			ajaxHideActivity();
		},
		error : function() {
			alert('Error occured');
			ajaxHideActivity();
			return false;
		}
	});

   $(\".wrap_fld .w_el_group\").hide();
   $(\"div#\"+$(el).val()).show();		
}
";

Portal::getInstance()->addScriptDeclaration($script);
?>
<div class="container">
	<div class="row">
		<div class="col-md-12">
			<div
				class="service-manager image-processor rounded-pan rounded-pan-medium">
				<h4 class="title"><?php echo Text::_("Image processor"); ?></h4>
				<p align="center" class="red"><?php echo Text::_("Beta version of module is for testing ONLY").".<br />".Text::_("We dont quarantee the correct working of your CMS while using it")."."; ?></p>
				<div id="tab_qpanel">
					<ul class="nav nav-tabs">
						<li class="active"><a data-toggle="mass_resize"
							href="#mass_resize"><?php echo Text::_("Mass resize"); ?></a></li>
						<li><a data-toggle="mass_optimize" href="#mass_optimize"><?php echo Text::_("Mass optimize"); ?></a></li>
						<li><a data-toggle="mass_webp" href="#mass_webp"><?php echo Text::_("Optimize image webp"); ?></a></li>
					</ul>
					<div class="tab-content">
						<div id="mass_resize" class="tab-pane">
							<form id="frmImageProcessor1" name="frmImageProcessor"
								action="index.php" method="post"
								onsubmit="return massResizeOnSubmit();">
								<h4 class="title"><?php echo Text::_("Select field for processing"); ?></h4>
								<div class="row">
									<div class="col-md-12"><?php
									$i = 0;
									foreach ( $this->objects as $k => $o ) {
										$i ++;
										echo "<div class=\"radio\"><label><input id=\"field_" . $i . "\" name=\"field_key\" type=\"radio\" value=\"" . $k . "\" required />" . $o ["title"] . " => " . $o ["field_title"] . " (" . $o ["width"] . "x" . $o ["height"] . ")</label></div>";
									}
									?></div>
								</div>
								<h4 class="title"><?php echo Text::_("Options"); ?></h4>
								<div class="row">
									<div class="col-md-12">
										<div class="checkbox">
											<input type="checkbox" id="skip_deleted" name="skip_deleted"
												value="1"><label for="skip_deleted"><?php echo Text::_("Skip deleted");?></label>
										</div>
										<div class="checkbox">
											<input type="checkbox" id="enabled_only" name="enabled_only"
												value="1"><label for="enabled_only"><?php echo Text::_("Enabled only");?></label>
										</div>
										<div class="checkbox">
											<input type="checkbox" id="force_from_source"
												name="force_from_source" value="1"><label
												for="force_from_source"><?php echo Text::_("Force resize from source");?></label>
										</div>
									</div>
								</div>
								<div class="row">
									<div class="col-md-12">
										<div class="checkbox">
											<input type="checkbox" id="i_understand_1"
												name="i_understand" value="1" /><label class="red"
												for="i_understand_1"><?php echo Text::_("I understand that this operation may cause damage to files and database");?></label>
										</div>
									</div>
								</div>
								<div class="row">
									<div class="col-md-12">
										<div class="buttons">
											<input type="submit" class="commonButtonbtn btn btn-info"
												value="<?php echo Text::_("Start"); ?>"> <input
												type="hidden" name="module" value="service"> <input
												type="hidden" name="view" value="imageprocessor"> <input
												type="hidden" name="task" value="processResize">
										</div>
									</div>
								</div>
							</form>
						</div>
						<div id="mass_optimize" class="tab-pane">
							<form id="frmImageProcessor2" name="frmImageProcessor"
								action="index.php" method="post"
								onsubmit="return massOptimizeOnSubmit();">
								<div class="row">
									<div class="col-md-12"></div>
								</div>
								<h4 class="title"><?php echo Text::_("Under construction"); ?></h4>
								<div class="row">
									<div class="col-md-12">
										<div class="checkbox">
											<input type="checkbox" id="i_understand_2"
												name="i_understand" value="1" /><label class="red"
												for="i_understand_2"><?php echo Text::_("I understand that this operation may cause damage to files and database");?></label>
										</div>
									</div>
								</div>
								<div class="row">
									<div class="col-md-12">
										<div class="buttons">
											<input type="submit" class="commonButtonbtn btn btn-info"
												value="<?php echo Text::_("Start"); ?>"> <input
												type="hidden" name="module" value="service"> <input
												type="hidden" name="view" value="imageprocessor"> <input
												type="hidden" name="task" value="startOptinmize">
										</div>
									</div>
								</div>
							</form>
						</div>

						<div id="mass_webp" class="tab-pane">
							<form id="frmImageProcessor3" name="frmImageProcessor"
								action="index.php" method="post"
								onsubmit="return massWebpOnSubmit();">
								<h4 class="title"><?php echo Text::_("Select object for processing"); ?></h4>
								<div class="row">
									<div class="col-md-12"><?php
									// $i=0;
									//Util::showArray($this->objects);
									$arrItemFld_list=array();
									foreach ( $this->objects as $k => $o ) {
										// разбираем ключ для организации списка
										$arr_k=explode("#",$k);
										
										$kwebp=$arr_k[0]."_".$arr_k[1];
										$arrItemFld_list[$kwebp][$arr_k[3]]=$o;
										$_arr [$kwebp] = $o ["title"] ;
										// $i++;
										// echo "<div class=\"radio\"><label><input id=\"field_".$i."\" name=\"field_key\" type=\"radio\" value=\"".$k."\" required />".$o["title"]." => ".$o["field_title"]." (".$o["width"]."x".$o["height"].")</label></div>";
									}
									echo HTMLControls::renderSelect ( "field_key", "field_1", false, false, $_arr, 0, false, 'setWebpProc(this)' );
									
									
									// в этом месте формируем списки полей для правки
									// отображаем по факту выбора
									echo "<div id=\"select_list_fld\"></div>";
									echo "<div class=\"wrap_fld\">";
									// тут у нас если папка - то указываем какую папку нам надо обработать
									foreach($arrItemFld_list as $kfl=>$vfl)
									{
										 
										echo "<div class=\"w_el_group\" id=\"".$kfl."\">";
										// это вариант просто папки
										if ($kfl == "service_folders") {
											echo "<p>" . Text::_ ( "Select folder for create webp images" ) . "</p>";
											/* тут создаем базовый селектор для мест где на сайте могут быть изображения
											 варианты : 
											 	template images // у нас список темплейтов морды плюс админки
											 	core images // одна папка 
											 	userfiles	// корень
											 											 	
											*/
											// формируем список
											$folders=array();
											$admin_templ = Files::getFolders(PATH_TEMPLATES,false,false);
											$front_templ = Files::getFolders(PATH_FRONT_TEMPLATES,false,false);
											foreach($admin_templ as $key=>$el){
												if($key=="."||$key=="..") continue;
												$folders[PATH_TEMPLATES.$el['filename']]=Text::_("admin template").":".$el['filename'];
											}
											foreach($front_templ as $key=>$el){
												if($key=="."||$key=="..") continue;
												$folders[PATH_FRONT_TEMPLATES.$el['filename']]=Text::_("template").":".$el['filename'];
											}
											$folders[PATH_FRONT."images"]=Text::_("Main images folder");
											//$folders[BARMAZ_UF_PATH]=Text::_("Userfiles");
											
											//Util::showArray($admin_templ,'admin_templ');
											//Util::showArray($front_templ,'front_templ');
											//BARMAZ_UF_PATH
																						
											//echo HTMLControls::renderInputFile( $kfl, "", "38", $kfl );
											echo HTMLControls::renderSelect ( $kfl, $kfl, false, false, $folders, 0, false, 'setFoldersWebp(this)' );
											echo HTMLControls::renderLabelField ( $kfl."_all", Text::_("Will refacted all images files in the folder"));
											echo HTMLControls::renderCheckbox ( $kfl."_all", "", "1", $kfl."_all");
											
										} else {

											// это сведения для полей в базе
											echo "<p>" . Text::_ ( "Select fields for convertations" ) . "</p>";
											foreach ( $vfl as $kf => $obf ) {
												// вот сюда надо выбор ограничитель для списков

												$key_fld = $obf ["module"] . "#" . $obf ["view"] . "#" . $obf ["layout"] . "#" . $obf ["field_name"];
												echo HTMLControls::renderLabelField ( $key_fld, $obf ["field_title"] );
												echo HTMLControls::renderCheckbox ( $kf, "", "1", $key_fld );
											}
										}
										
										echo "</div>";
										
									}
									echo "</div>";
									
									?></div>
								</div>
								<h4 class="title"><?php echo Text::_("Options"); ?></h4>
								<div class="row">
									<div class="col-md-12">
										<div id="selected_item"></div>
										<div class="checkbox">
											<input type="checkbox" id="w_skip_deleted"
												name="w_skip_deleted" value="1"><label for="skip_deleted"><?php echo Text::_("Skip deleted");?></label>
										</div>
										<div class="checkbox">
											<input type="checkbox" id="w_enabled_only"
												name="w_enabled_only" value="1"><label for="enabled_only"><?php echo Text::_("Enabled only");?></label>
										</div>
										<div class="checkbox">
											<input type="checkbox" id="w_force_from_source"
												name="w_force_from_source" value="1"><label
												for="force_from_source"><?php echo Text::_("Force resize from source");?></label>
										</div>
										<div class="checkbox">
											<input type="checkbox" id="w_delete_source"
												name="w_delete_source" value="1"><label
												for="force_from_source"><?php echo Text::_("Delete source file");?></label>
										</div>
									</div>
								</div>
								<div class="row">
									<div class="col-md-12">
										<div class="checkbox">
											<input type="checkbox" id="w_i_understand"
												name="w_i_understand" value="1" /><label class="red"
												for="w_i_understand"><?php echo Text::_("I understand that this operation may cause damage to files and database");?></label>
										</div>
									</div>
								</div>
								<div class="row">
									<div class="col-md-12">
										<div class="buttons">
											<input type="submit" class="commonButtonbtn btn btn-info"
												value="<?php echo Text::_("Start"); ?>"> <input
												type="hidden" name="module" value="service"> <input
												type="hidden" name="view" value="imageprocessor"> <input
												type="hidden" name="task" value="processWebpcreate">
										</div>
									</div>
								</div>
							</form>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
<?php 
//Util::showArray($this->objects); 
?>