<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : user 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.0 (2023/04/04)
//  Build: 203 (2024-01-07 23:14:41)
// 


defined('_BARMAZ_VALID') or die("Access denied");

class defaultViewauth_providers extends SpravView {
	public function modify($row) {
		if(is_object($row)){
			if($row->sn_key && $row->sn_secret){
				$crypt = new Crypta ();
				$row->sn_key = $crypt->xxtea_decrypt(base64_decode($row->sn_key), backofficeConfig::$secretCode);
				$row->sn_secret = $crypt->xxtea_decrypt(base64_decode($row->sn_secret), backofficeConfig::$secretCode);
			} else {
				$row->sn_key = "";
				$row->sn_secret = "";
			}
		} else {
			$row = new stdClass();
			$row->sn_key = "";
			$row->sn_secret = "";
		}
		parent::modify($row);
	}
}
?>