<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : gallery 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.0 (2023/04/04)
//  Build: 203 (2024-01-07 23:14:41)
// 


defined('_BARMAZ_VALID') or die("Access denied");

class galleryModule extends Module {
	public function prepare() {
		/* Not need here if is set in module settings */ $this->setDefaultView('groups');
	}
	public function getSitemapHTML() {
		$db=Database::getInstance();
		$module=$this->getName();
		$result = array("html"=>"","links"=>array());
		$sql = "SELECT gr.gr_id, gr.gr_title, gr.gr_alias,g.g_id,g.g_title,g.g_alias 
				FROM #__galleries as g, #__gallery_groups as gr 
				WHERE gr.gr_id = g.g_group_id 
				AND gr.gr_deleted=0 AND gr.gr_published=1 AND gr.gr_show_in_list=1 
				AND g.g_deleted=0 AND g.g_published=1 AND g.g_show_in_list=1
				ORDER BY gr.gr_title";
		$db->setQuery($sql);
		$res=$db->loadObjectList();
		$html='';
		$current_category=NULL;
		$html='';
		$ul_started=0;
		if(count($res)) {
			$html.="<ul>";
			foreach($res as $gal) {
				if($current_category!=$gal->gr_id&&!is_null($gal->gr_id)) {
					if($ul_started) $html.="</ul></li>";
					$html.="<li><a href=\"".Router::_("index.php?module=gallery&view=items&psid=".$gal->gr_id."&alias=".$gal->gr_alias)."\">".$gal->gr_title."</a>";
					$html.="<ul>";
					$html.="<li><a href=\"".Router::_("index.php?module=gallery&view=images&psid=".$gal->g_id."&alias=".$gal->g_alias)."\">".$gal->g_title."</a></li>";
					$ul_started++;
					$current_category=$gal->gr_id;
				} else {
					$html.="<li><a href=\"".Router::_("index.php?module=gallery&view=images&psid=".$gal->g_id."&alias=".$gal->g_alias)."\">".$gal->g_title."</a></li>";
				}
			}
			if($ul_started) $html.="</ul></li>";
			$html.="</ul>";
		}
		$result["title_link"]=true;
		$result['html']=$html;
		return $result;
	}	
}
?>