<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : gallery 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.0 (2023/04/04)
//  Build: 203 (2024-01-07 23:14:41)
// 


defined('_BARMAZ_VALID') or die("Access denied");

echo "<h1 class=\"title\">".Text::_("Gallery groups")."</h1>";
if (count($this->groups)) {
	if(galleryConfig::$ggr_thumbWidth) $autowidth=" style=\"width:".galleryConfig::$ggr_thumbWidth."px;\""; else $autowidth="";
	foreach($this->groups as $group) {
		$href="index.php?module=gallery&amp;view=items&amp;psid=".$group->gr_id;
		if ($group->gr_alias) $href.="&amp;alias=".$group->gr_alias;
		echo "<div class=\"gallerygroup row\">";
		echo "<div class=\"col-md-12\"><h3>";
		echo "<a class=\"gallery-title\" href=\"".Router::_($href)."\">";
		echo $group->gr_title."</a>";
		echo "</h3></div>";

		echo "<div class=\"thumb col-sm-3\">";
		if ($group->gr_thumb) $img=BARMAZ_UF_PATH.'gallery'.DS.'groups'.DS.'thumbs'.DS.Files::getAppendix($group->gr_thumb).DS.$group->gr_thumb;
		else $img="";
		if($img && is_file($img)) {
			$img_link=BARMAZ_UF.'/gallery/groups/thumbs/'.Files::getAppendix($group->gr_thumb)."/".$group->gr_thumb;
			echo "<a class=\"group-image\" href=\"".Router::_($href)."\">";
			echo "<img".$autowidth." title=\"".$group->gr_title_thm."\" alt=\"".$group->gr_alt_thm."\" class=\"group-image\" src=\"".$img_link."\" /></a>";
		}	else {
			echo "<a class=\"group-image\" href=\"".Router::_($href)."\">";
			echo "<img width=\"1\" height=\"1\"".$autowidth." alt=\"\" class=\"empty-img\" src=\"/images/blank.webp\" /></a>";
		}
		echo "</div><div class=\"comment col-sm-9\">".$group->gr_comment."</div>";
		echo "</div>";
	}
}
?>