<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : pools 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.0 (2023/04/04)
//  Build: 203 (2024-01-07 23:14:41)
// 


defined('_BARMAZ_VALID') or die("Access denied");

class pollsControllerdefault extends SpravController {

	public function showPolls() {
		$psid	= $this->getPsid();
		$layout = $this->get('layout');
		$model = $this->getModel();
		$view = $this->getView();
		$view->addBreadcrumb(Text::_('Polls'),"index.php?module=polls");
		$this->checkACL("viewPollsAllResults");

		$pollsCount = $model->getPollsCount();
		$paginator = $model->createPaginator($view, $pollsCount);
		$polls = $model->getPolls();
		$items = $model->getItems($polls);
		$view->assign("setVoteButton",false);
		$view->assign("polls",$polls);
		$view->assign("items",$items);
		$pg_link="index.php?module=polls&amp;psid=".$psid;
		$paginator->buildPagePanel($pg_link,"");
	}
	public function showPoll() {
		$psid	= $this->getPsid();
		if($psid) {
			$layout = $this->get('layout');
			$model = $this->getModel("polls");
			$view = $this->getView();
			$view->addBreadcrumb(Text::_('Polls'),"index.php?module=polls");
			$this->checkACL("viewPollsAllResults");
			$poll = $model->getPoll($psid);
			if(is_object($poll)){
				$items = $model->getItems(array($poll));
				$view->assign("setVoteButton",false);
				$view->assign("poll",$poll);
				$view->assign("items",$items);
			} else $this->setRedirect("index.php?module=polls", Text::_("Page not found"), 404);
		} else $this->setRedirect("index.php?module=polls", Text::_("Page not found"), 404);
	}
	public function ajaxgetVotePanel() {
		$psid=Request::getSafe('psid',0);
		$model = new Polls();
		$poll = $model->getPollByItem($psid);	
		
	}
	
	public function ajaxPollVote() {
		$psid=Request::getSafe('psid',0);
		$model = new Polls();
		$poll = $model->getPollByItem($psid);	
		
		if ($poll) {
			if ($model->allreadyVoted($poll)) {
				$html = "<p class=\"poll_error\">".Text::_("You have already voted in this poll")."</p>";
			} else {
				if ($this->checkACL("pollsModuleVote",0)) {
					if ($model->votePoll($psid)) {
						$model->setCookieLag($poll);
						$html = "<p class=\"poll_message\">".Text::_("Thank you for your vote")."</p>";
					} else $html = "<p class=\"poll_error\">".Text::_("Error while polling")."</p>";
				} else $html = "<p class=\"poll_error\">".Text::_("You cannot vote in polls")."</p>";
			}
			$items= $model->getItems($poll->p_id);	
			$html.=Widget::getInstance("polls")->renderPoll($poll,$items);
		} else $html = "<p class=\"poll_error\">".Text::_("Server Request error")."</p>";
		echo $html;
	}
}

?>