<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : user 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.0 (2023/04/04)
//  Build: 203 (2024-01-07 23:14:41)
// 


defined('_BARMAZ_VALID') or die("Access denied");

$profile = $this->profile;
if(!empty($profile["pf_img"]["val"])) {
	$img_path=BARMAZ_UF_PATH."user".DS."i".DS."avatars".DS.$profile["pf_img"]["val"];
	if (is_file($img_path))	$img='<img width="100" src="'.BARMAZ_UF.'/user/i/avatars/'.$profile["pf_img"]["val"].'" alt="" />'; 	
	else $img='<img class="avatar" alt="" src="/templates/'.Portal::getInstance()->getTemplate().'/images/nofoto.webp">';
} else $img='<img class="avatar" alt="" src="/templates/'.Portal::getInstance()->getTemplate().'/images/nofoto.webp">';
$about = str_replace("\n", "<br />",$profile["pf_text"]["val"]);

Portal::getInstance()->setTitle( Text::_("User info")." ".$this->nickname );
?>

<div class="userinfo">
	<h1 class="title"><?php echo Text::_("User info")." ".$this->nickname;?></h1>
	<div id="usercontacts">
<?php	foreach($profile as $key=>$val) {
		if ($key=="pf_img" || $key=="pf_text") continue;
		echo "<div class=\"row\">";
		echo "<div class=\"col-md-6\">";
		echo HTMLControls::renderLabelField(false, $val["title"].": ");
		echo "</div><div class=\"col-md-6\">";
		echo $val["val"];
		echo "</div>";
		echo "</div>";
} ?>
	</div>
	<div id="userabout" class="row">
		<div class="col-md-4"><?php echo $img ?></div>
		<div class="col-md-8"><?php echo $about; ?></div>
	</div>
	<?php if($this->canWriteToUser) {?>
		<div id="userlink" class="buttons">
			<a class="commonButton btn btn-info" href="<?php echo Router::_("index.php?module=mail&view=write&recvuid=".$this->psid); ?>"><?php echo Text::_("Write personal message"); ?></a>
		</div>
	<?php } ?>
</div>
