<?php
//  BARMAZ erp system
//  Copyright (c) BARMAZ Group
//  Web: https://BARMAZ.ru/
//  Commercial license https://BARMAZ.ru/article/litsenzionnoe-soglashenie.html
//  THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
//  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
//  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
//  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
//  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//  Revision: 203 (2024-01-07 23:05:31)
// 

//  BARMAZ-ERP
//  Package : module 
//  name : videoset 
//  Copyright (c) BARMAZ Group
//  Revision: 1.0.0 (2023/04/04)
//  Build: 203 (2024-01-07 23:14:41)
// 


defined('_BARMAZ_VALID') or die("Access denied");

class videosetModule extends Module {
	public function prepare() {
		/* Not need here if is set in module settings */ $this->setDefaultView('groups');
	}
	public function getSitemapHTML() {
		$db=Database::getInstance();
		$module=$this->getName();
		$result = array("html"=>"","links"=>array());
		$sql = "SELECT gr.vgr_id, gr.vgr_title, gr.vgr_alias,g.vg_id,g.vg_title,g.vg_alias
				FROM #__videoset_galleries as g, #__videoset_groups as gr
				WHERE gr.vgr_id = g.vg_group_id AND gr.vgr_deleted=0 AND gr.vgr_published=1 AND gr.vgr_show_in_list=1
				AND g.vg_deleted=0 AND g.vg_published=1 AND g.vg_show_in_list=1";
		$db->setQuery($sql);
		$res=$db->loadObjectList();
		$html='';
		$current_category=NULL;
		$html='';
		$ul_started=0;
		if(count($res))
		{
			$html.="<ul>";
			foreach($res as $gal)
			{
				if($current_category!=$gal->vgr_id&&!is_null($gal->vgr_id))
				{
					if($ul_started) $html.="</ul></li>";
					$html.="<li><a href=\"".Router::_("index.php?module=videoset&view=items&psid=".$gal->vgr_id."&alias=".$gal->vgr_alias)."\">".$gal->vgr_title."</a>";
					$html.="<ul>";
					$html.="<li><a href=\"".Router::_("index.php?module=videoset&view=videos&psid=".$gal->vg_id."&alias=".$gal->vg_alias)."\">".$gal->vg_title."</a></li>";
					$ul_started++;
					$current_category=$gal->vgr_id;
				}
				else {
					$html.="<li><a href=\"".Router::_("index.php?module=videoset&view=videos&psid=".$gal->vg_id."&alias=".$gal->vg_alias)."\">".$gal->vg_title."</a></li>";
				}
			}
			if($ul_started) $html.="</ul></li>";
			$html.="</ul>";
		}
		$result["title_link"]=true;
		$result['html']=$html;
		return $result;
	}
}
?>